Package: SVMDO
Title: Identification of Tumor-Discriminating mRNA Signatures via
        Support Vector Machines Supported by Disease Ontology
Version: 1.11.0
Date: 2024-08-30
Authors@R: 
    c(person(given = "Mustafa Erhan",
	family = "Ozer",
    role = c("aut","cre"),
    comment = c(ORCID = "0000-0002-1572-8008"),
    email = "erhanozer19@marun.edu.tr"),
    person(given = "Pemra",
    family = "Ozbek Sarica",
    role = "aut",
    email = "pemra.ozbek@marmara.edu.tr"),
    person(given = "Kazim Yalcin",
    family = "Arga",
    role = "aut",
    email = "kazim.arga@marmara.edu.tr"))      
Depends: R(>= 4.4), shiny (>= 1.7.4)
Imports: shinyFiles (>= 0.9.3), shinytitle (>= 0.1.0), golem (>=
        0.3.5), nortest (>= 1.0-4), e1071 (>= 1.7-12), BSDA (>= 1.2.1),
        data.table (>= 1.14.6), sjmisc (>= 2.8.9), klaR (>= 1.7-1),
        caTools (>= 1.18.2), caret (>= 6.0-93), survival (>= 3.4-0), DT
        (>= 0.33.0), DOSE (>= 3.24.2), AnnotationDbi (>= 1.60.0),
        org.Hs.eg.db (>= 3.16.0), dplyr (>= 1.0.10),
        SummarizedExperiment (>= 1.28.0), grDevices, graphics, stats,
        utils
Description: It is an easy-to-use GUI using disease information for detecting 
            tumor/normal sample discriminating gene sets from differentially 
            expressed genes. Our approach is based on an iterative algorithm 
            filtering genes with disease ontology enrichment analysis and wilk 
            and wilks lambda criterion connected to SVM classification model 
            construction. Along with gene set extraction, SVMDO also provides 
            individual prognostic marker detection. The algorithm is designed 
            for FPKM and RPKM normalized RNA-Seq transcriptome datasets. 
RoxygenNote: 7.3.2
biocViews: GeneSetEnrichment, DifferentialExpression, GUI,
        Classification, RNASeq, Transcriptomics, Survival
NeedsCompilation: no
License: GPL-3
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
Suggests: BiocStyle, knitr, rmarkdown, testthat (>= 3.1.6)
VignetteBuilder: knitr
Config/testthat/edition: 3
BugReports: https://github.com/robogeno/SVMDO/issues
git_url: https://git.bioconductor.org/packages/SVMDO
git_branch: devel
git_last_commit: 2bc7e27
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
Packaged: 2025-11-01 00:32:13 UTC; biocbuild
Author: Mustafa Erhan Ozer [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1572-8008>),
  Pemra Ozbek Sarica [aut],
  Kazim Yalcin Arga [aut]
Maintainer: Mustafa Erhan Ozer <erhanozer19@marun.edu.tr>

# SVMDO

## Overview
SVMDO is a R package providing Shiny-based web application for extracting disease-associated and normal/tumor tissue sample discriminating gene sets. 

![](vignettes/algorithm_figure.png)

Using FPKM and RPKM normalized RNA-Seq transcriptomics data, the package follows the steps displayed in **Figure-1**:

1. **Differential Expression Analysis**: Extracting differentially expressed genes from RNA-Seq datasets downloaded from either TCGA or GEO databases.
2. **Feature Selection**: Filtration of differentially expressed genes with Disease Ontology Enrichment Analysis.
3. **Gene Set Trimming and Classification**: Wilk's Lambda based discriminative gene set preparation for SVM classification.
4. **Prognostic Performance**: Single gene survival analysis of discriminative sets providing classification.

## Installation

To install any package from Bioconductor, run the following command in your R console:
```
if (!requireNamespace("BiocManager", quietly = TRUE))
install.packages("BiocManager")
```

To install the SVMDO package using BiocManager, run the following command in your R console:
```
BiocManager::install("SVMDO")
```

The recent version can be downloaded from [Github repository](https://github.com/robogeno/SVMDO):
```
install.packages("devtools")
devtools::install_github("robogeno/SVMDO")
```

## Package tutorial
A vignette file is available at [this link](https://github.com/robogeno/SVMDO/blob/master/vignettes/SVMDO_guide.Rmd). To see the html version, use vignette("SVMDO_guide.Rmd"). Note: if you want to install from Github, please specify build_vignettes = TRUE in install_github.

## Licence and use
SVMDO is a free software; you can redistribute it and/or modify it under the terms of the GNU General Public License 3 (GPL 3) as published by the Free Software Foundation. It is distributed in the hope that it will be useful, but without any warranty and without even the implied warranty of merchantability or fitness for a particular purpose. See the GNU General Public License for more details.

#' @title SVMDO
#' @name do_based_gene_filtration_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of disease ontology based filtration of differentially expressed genes
innerServer_6<-function(input,output,session){
  observeEvent(input$initiate_do_analysis, {
    message_val_3<-NULL
    normal_samples<-NULL
    tumour_samples<-NULL
    disease_filtered_gene_data<-NULL
    changed_name_plus_var_imp_genes_table<-NULL
    
    if (exists("top_genes_test")) {
      top_genes<-top_genes_test
    }
    
    if (exists("tissue_type_list") & exists("top_genes")) {
      changed_whole_data<-cbind(tissue_type_list,top_genes)
      collect_gene_names<-NULL
      selected_data<-colnames(changed_whole_data)[-1]
      
      checking_data<-selected_data
      checking_data<-as.character(checking_data)
      checking_data<-gsub( "__", "-",checking_data)
      
      colnames(changed_whole_data[,seq.int(2,ncol(changed_whole_data))])<-checking_data
      database_selection<-select(org.Hs.eg.db, keys = checking_data,columns = c("ENTREZID", "SYMBOL"),keytype = "SYMBOL")
      
      pop_gene_id<-(database_selection$ENTREZID)
      pop_gene_symbol<-database_selection$SYMBOL
      count_gene_id<-length(database_selection$ENTREZID)
      
      dis_gene_extract<-lapply(seq_along(pop_gene_id),function(x){
        disease_enrichment<-enrichDO(pop_gene_id[x],ont = "HDO")
        if (!is.null(disease_enrichment)){
          dis_length<-length(disease_enrichment[1]$Description)
          p_check<-(disease_enrichment[1]$p.adjust[1])
          if (dis_length > 0){
            if (isTRUE(p_check < 0.05)==TRUE) {
              selected_gene_list<-c(collect_gene_names,pop_gene_symbol[x])
            }
          }
        }
      })
      
      collect_gene_names<-unlist(dis_gene_extract)
      collect_gene_names<-gsub( "-", "__",collect_gene_names)
      changed_whole_data<-changed_whole_data[,-1]
      changed_name_plus_var_imp_genes_table<-subset(changed_whole_data,select=(collect_gene_names))
      
      samp_select_norm<-lapply(seq.int(nrow(tissue_type_list)), function(x){
        if (str_contains(tissue_type_list$tissue_type[x],"Nor")) {
          normal_samples<-rbind("normal",normal_samples)
        }})
      samp_select_tum<-lapply(seq.int(nrow(tissue_type_list)), function(x){
        if (str_contains(tissue_type_list$tissue_type[x],"Tum")) {
          tumour_samples<-rbind("tumour",tumour_samples)
        }
      })
      
      normal_samples<-as.data.frame(unlist(samp_select_norm))
      tumour_samples<-as.data.frame(unlist(samp_select_tum))
      colnames(normal_samples)<-"tissue_type"
      colnames(tumour_samples)<-"tissue_type"
      assigning_new_tissue_type_list<-rbind(normal_samples,tumour_samples)
      rownames(assigning_new_tissue_type_list)<-NULL
      assign("new_tissue_type_list",assigning_new_tissue_type_list,envir = .GlobalEnv)
      
      if(exists("tcga_id_list")){
        tcga_id_list$id<-as.character(gsub("-", ".", tcga_id_list$id, fixed = TRUE))
        assigning_tcga_sample_comb<-cbind(tcga_id_list,new_tissue_type_list)
        assign("tcga_sample_comb",assigning_tcga_sample_comb,envir =.GlobalEnv)
      }
      
      assigning_disease_filtered_gene_data<-cbind(new_tissue_type_list,changed_name_plus_var_imp_genes_table)
      assigning_disease_filtered_gene_data<-as.data.frame(assigning_disease_filtered_gene_data)
      assign("disease_filtered_gene_data",assigning_disease_filtered_gene_data,envir = .GlobalEnv)

      message_val_3<-1
    }
    if (!is.null(message_val_3)) {
      
      showModal(
        modalDialog(
          title = "DO based Gene Filtration",
          "Process Completed",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }else{
      showModal(
        modalDialog(
          title = "Error in DO Analysis",
          "Missing Top Gene Number Selection Step",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
    
  })
}

#' @title SVMDO
#' @name deg_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @param rawData expression dataset provided from innerServer_exp_server
#' @param rval Selected radio button information provided from innerServer_rad_server
#' @return Server section of differential gene expression analysis


innerServer_3 <- function(input, output, session,rawData, rval) {
  observeEvent(input$initiate_deg_analysis, {
    
    main_process_activation<-NULL
    test_activation<-NULL
    rval_sel<-rval()

    if (rval_sel=="COAD") {
      package_path<-find.package("SVMDO",quiet=TRUE)
      rds_path<-"extdata/coad_exp_sum.rds"
      comb_path<-file.path(package_path,rds_path,fsep = "/")
      c<-readRDS(comb_path)
      c<-assay(c)
      type_num_data<-seq.int(ncol(c))
      type_data<-c[1,type_num_data]
    } else if (rval_sel=="LUSC"){
      package_path<-find.package("SVMDO",quiet=TRUE)
      rds_path<-"extdata/lusc_exp_sum.rds"
      comb_path<-file.path(package_path,rds_path,fsep = "/")
      c<-readRDS(comb_path)
      c<-assay(c)
      type_num_data<-seq.int(ncol(c))
      type_data<-c[1,type_num_data]
    }else{
      c<-rawData()
      type_num_data<-seq.int(ncol(c))
      type_data<-c[1,..type_num_data]
    }
    
    if (colnames(c)[1] =="id" | colnames(c)[1] =="tissue_type" | 
        colnames(c)[2] =="tissue_type" & ncol(c)>3) {
      type_apply_1<-lapply(type_data,is.character)
      type_loc_1<-as.numeric(min((which(type_apply_1==TRUE))))
      
      if (!is.character(c[[type_loc_1+1]])) {
        
        type_loc_2<-type_loc_1+1
        col_val_1<-type_loc_1
        col_val_2<-type_loc_2
        
        assigning_tissue_type_list<-as.data.frame(c[[col_val_1]])
        colnames(assigning_tissue_type_list)<-c("tissue_type")
        assign("tissue_type_list",assigning_tissue_type_list,envir =.GlobalEnv)
        
        start_val<-type_loc_1
        num_data<-start_val+1
      }else{
        type_loc_2<-type_loc_1+2
        col_val_1<-type_loc_1
        col_val_2<-type_loc_2
        
        assigning_tcga_id_list<-as.data.frame(c[[col_val_1]])
        assigning_tissue_type_list<-as.data.frame(c[[col_val_1+1]])
        
        colnames(assigning_tcga_id_list)<-data.frame("id")
        colnames(assigning_tissue_type_list)<-c("tissue_type")
        
        assign("tissue_type_list",assigning_tissue_type_list,envir =.GlobalEnv)
        assign("tcga_id_list",assigning_tcga_id_list,envir =.GlobalEnv)
        
        start_val<-type_loc_1+1
        num_data<-start_val+2
        
      }
      
      c<-c[,num_data:ncol(c)]
      c<-cbind(tissue_type_list,c)
      
      normal_data<-NULL
      tumour_data<-NULL
      p_val_total<-NULL
      normal_data_mean<-NULL
      tumour_data_mean<-NULL
      dist_normal_pval<-NULL
      dist_tumour_pval<-NULL
      
      colnames(c)<-(make.unique(colnames(c)))
      
      #####Modifying illegal symbols
      colnames(c)<-gsub( "-", "__",  colnames(c))
      colnames(c)<-gsub( " ", "__",  colnames(c))
      colnames(c)<-gsub( ";. ", "__",colnames(c))
      colnames(c)<-gsub( ";__","__", colnames(c))
      #####
      
      ############ Normal and Tumour Data Extraction and Fold Change Calculation
      
      normal_data<-c[grep("Nor",c$tissue_type),]
      tumour_data<-c[grep("Tum",c$tissue_type),]
      
      num_data_norm<-(seq.int(start_val,ncol(normal_data)))
      num_data_tum<-(seq.int(start_val,ncol(tumour_data)))
      normal_data_mean<-colMeans(normal_data[,num_data_norm])
      tumour_data_mean<-colMeans(tumour_data[,num_data_tum])
      
      fold_change<-tumour_data_mean/normal_data_mean
      matr_fold<-as.matrix(fold_change)
      
      i<-start_val
      u<-start_val
      s<-start_val
      
      dist_normal_pval<-ad.test(normal_data[[i]][seq.int(ncol(normal_data))])$p.value
      dist_tumour_pval<-ad.test(tumour_data[[i]][seq.int(ncol(tumour_data))])$p.value
      
      repeat{
        if (!is.null(dist_normal_pval) & (dist_normal_pval>=0.05 | dist_tumour_pval>=0.05)) {
          dist_normal_pval<-ad.test(normal_data[[i]][seq.int(ncol(normal_data))])$p.value
          dist_tumour_pval<-ad.test(tumour_data[[i]][seq.int(ncol(tumour_data))])$p.value
          if (i==ncol(normal_data)) {
            p_val<-z.test(normal_data[[s]],tumour_data[[s]],sigma.x = sd(normal_data[[s]]),sigma.y = sd(tumour_data[[s]]))$p.value
            p_val_total<-c(p_val_total,p_val)
            s<-s+1
          }else{
            i<-i+1
          }
        }
        
        if (dist_normal_pval<0.05 | dist_tumour_pval<0.05) {
          p_val<-wilcox.test(as.numeric(unlist(normal_data[[u]])),as.numeric(unlist(tumour_data[[u]])))$p.value
          p_val_total<-c(p_val_total,p_val)
          u<-u+1
        }
        if (u>ncol(normal_data) | s>ncol(normal_data)) {
          break
        }
      }
      
      padjust<-p.adjust(p_val_total,method = "BH")
      p_val_total<-padjust
      rownames(p_val_total)<-NULL
      filtered_p_val_total<-subset(p_val_total,p_val_total<0.05)
      bound_form<-cbind.data.frame(matr_fold,p_val_total)
      colnames(bound_form)<-c("Fold_Change","P_value(adjusted)")
      new_bound_form<-subset(bound_form,bound_form$Fold_Change!="Inf" & bound_form$Fold_Change!="-Inf"
                             &bound_form$Fold_Change!="NaN" &bound_form$`P_value(adjusted)`<0.05 &bound_form$`P_value(adjusted)`!="NaN")
      
      new_bound_form_A<-subset(new_bound_form,new_bound_form$Fold_Change<= 0.3535534)
      new_bound_form_B<-subset(new_bound_form,new_bound_form$Fold_Change>= 2.828427)
      
      new_bound_form_A<-cbind.data.frame(rownames(new_bound_form_A),new_bound_form_A)
      new_bound_form_B<-cbind.data.frame(rownames(new_bound_form_B),new_bound_form_B)
      colnames(new_bound_form_A)<-c("Genes","Fold_Change","P_value")
      colnames(new_bound_form_B)<-c("Genes","Fold_Change","P_value")
      complete_deg_gene_list<-rbind(new_bound_form_A,new_bound_form_B)
      
      sorted_new_bound_form_A<-new_bound_form_A[order(-new_bound_form_A$Fold_Change),]
      sorted_new_bound_form_B<-new_bound_form_B[order(new_bound_form_B$Fold_Change),]
      
      if (rval_sel %in% c("COAD","LUSC")) {
        top_gene_number<-50
        assign("sorted_new_bound_form_A_test",sorted_new_bound_form_A,envir =.GlobalEnv)
        assign("sorted_new_bound_form_B_test",sorted_new_bound_form_B,envir =.GlobalEnv)
        assign("complete_deg_gene_list_test",complete_deg_gene_list,envir =.GlobalEnv)
        assign("total_exp_dataset_test",c, envir =.GlobalEnv)
        
        max_down_genes_test<-sorted_new_bound_form_A_test[seq.int((nrow(sorted_new_bound_form_A_test)-(top_gene_number-1)),nrow(sorted_new_bound_form_A_test)),]
        max_up_genes_test<-sorted_new_bound_form_B_test[seq.int((nrow(sorted_new_bound_form_B_test)-(top_gene_number-1)),nrow(sorted_new_bound_form_B_test)),]
        top_combined_genes_test<-rbind(max_down_genes_test,max_up_genes_test)
        rownames(top_combined_genes_test)<-top_combined_genes_test[,1]
        changed_whole_data_test<-subset(c,select=top_combined_genes_test$Genes)
        assign("top_genes_test",changed_whole_data_test,envir =.GlobalEnv)
        test_activation<-1
      }else{
        assign("sorted_new_bound_form_A",sorted_new_bound_form_A,envir =.GlobalEnv)
        assign("sorted_new_bound_form_B",sorted_new_bound_form_B,envir =.GlobalEnv)
        assign("complete_deg_gene_list",complete_deg_gene_list,envir =.GlobalEnv)
        assign("total_exp_dataset",c, envir =.GlobalEnv)
        main_process_activation<-1
      }
      
      if (!is.null(main_process_activation)) {
        showModal(
          modalDialog(
            title = "Input Data-Based DEG Analysis",
            "Process Completed",
            easyClose = TRUE,
            footer = NULL
          )
        )
      }
      
      if (!is.null(test_activation)) {
        showModal(
          modalDialog(
            title = "Test Data-Based DEG Analysis",
            "Process Completed",
            easyClose = TRUE,
            footer = NULL
          )
        )
      }
    }else{
      showModal(
        modalDialog(
          title = "Detecting Dataset Incompatibility",
          "Please Check Manual (Vignette) for Expression Dataset Preparation",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
  })
}

#' @title SVMDO
#' @name table_ui
#' @param id connection input
#' @return UI section of providing discriminative gene set for preparing table


innerUI_table_show <- function(id) {
  ns <- NS(id)
  actionButton(ns("file"),"Show Gene Results")}

#' @title SVMDO
#' @name clinic_data_input_ui
#' @param id connection input
#' @return UI section of loading clinical data 

# Clinical dataset to be used in survival analysis consists of 3 main columns:
# TCGA id
# Patient Days to Death Information
# Patient Vital Status (Death/Alive)


innerUI_clinic_data <- function(id) {
  ns <- NS(id)
  fluidRow(
    column(4,
           fileInput(ns("file2"),
                     "Choose Clinical Data",
                     accept = ".txt")))
}

#' @title SVMDO
#' @name do_based_gene_filtration_ui
#' @param id connection input
#' @return UI section of disease ontology based filtration of differentially expressed genes

innerUI_disease_ont_class<- function(id){
  ns <- NS(id)
  actionButton(ns("initiate_do_analysis"),"DO Analysis")
}

#' @title SVMDO
#' @name gene_list_table_visualization_ui
#' @param id connection input
#' @return Providing table form of discriminative gene sets in GUI

deg_data_table_ui  <- function(id){
  ns <- NS(id)
  tagList(
    dataTableOutput(outputId = ns("table")),
    textOutput(outputId = ns("my_text"))  
  )  
}

#' @title SVMDO
#' @name survival_analysis_ui
#' @param id connection input
#' @return UI section of survival analysis of final discriminative gene set


innerUI_surv<-function(id){
  ns <- NS(id)
  actionButton(ns("initiate_surv_analysis"),"Survival Analysis")
}

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  warning = FALSE,
  comment = "#>",
  cache = TRUE
)


is_windows <- identical(.Platform$OS.type, "windows")

## ----install, eval=FALSE------------------------------------------------------
# # From Github
# if (!requireNamespace("devtools", quietly=TRUE))
#   install.packages("devtools")
# devtools::install_github("robogeno/SVMDO")

## ----eval = FALSE-------------------------------------------------------------
# # From Biocodunctor
# if(!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("SVMDO")

## ----eval = FALSE-------------------------------------------------------------
# #library(SVMDO)
# #Main screen of GUI
# #runGUI()
# # OR
# #SVMDO::runGUI()

## ----echo=FALSE---------------------------------------------------------------
id<-c("TCGA-AA-3662","TCGA-AA-3514","TCGA-D5-6541","...")
tissue_type<-c("Normal","Normal","Tumour","...")
AB1G<-c("Exp_1","Exp_2","Exp_3","...")
A2M<-c("Exp_1","Exp_2","Exp_3","...")
table_prep_1<-data.frame(id,tissue_type,AB1G,A2M)

## ----echo=FALSE---------------------------------------------------------------
id<-c("TCGA-AA-3662","TCGA-AA-3514","TCGA-D5-6541","...")
days_to_death<-c(49,1331,225,"...")
vital_status<-c("Alive","Dead","Dead","...")
table_prep_2<-data.frame(id,days_to_death,vital_status)

## ----,echo=FALSE,  width = 200, height = 50,fig.align = "center",fig.show='hold'----
# two figs side by side
knitr::include_graphics("svmdo_fig_1.png")

## ----,echo=FALSE,  width = 200, height = 50,fig.align = "center",fig.show='hold',fig.cap='Figure-1 SVMDO GUI Sections'----
# two figs side by side
knitr::include_graphics("svmdo_fig_2.png")

## ----SessionInfo, eval=TRUE, message=FALSE, echo=FALSE------------------------
sessionInfo()

#' @title SVMDO
#' @name top_val_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of entering top gene value

innerServer_4<-function(input, output, session) {
  top_val <- reactive({input$num_val})
  return(top_val)  
}

#' @title SVMDO
#' @name innerServer_exp_ui
#' @param id connection input
#' @return UI section of providing expression dataset into GUI

# Expression dataset to be used in DEG analysis consists of 3 main columns:
# TCGA id
# Tissue type (Normal/Tumour)
# Expression values (Named with Gene Symbols)

# If there is not any requirements for survival analysis, TCGA id is not required

innerUI_exp_data <- function(id) {
  ns <- NS(id)
  fluidRow(
    column(4,
           fileInput(ns("file1"),
                     "Choose Your Expression Dataset",
                     accept = ".txt")))
}

#' @title SVMDO
#' @name classification_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of wilks lambda filtration and SVM classification of disease filtered differentially expressed gene set

innerServer_7<-function(input,output,session) {
  observeEvent(input$initiate_wlsvmdo_analysis, {
    test_spec<-NULL
    train_spec<-NULL
    test_pval<-NULL
    train_pval<-NULL
    test_kappa<-NULL
    train_kappa<-NULL
    elected_genes<-NULL
    elected_genes_before<-NULL
    skip_value<-NULL
    nameless_disease_filtered_gene_data<-NULL
    disease_filtered_gene_data_before<-NULL
    para_fixer<-NULL
    final_elected_check<-NULL
    train_test_val_check<-NULL
    
    specific_check_val<-0
    niv_value<-0.1
    
    if (exists("new_tissue_type_list")) {
      
      all_names<-new_tissue_type_list
      actual_disease_filtered_gene_data<-subset(disease_filtered_gene_data,select=-tissue_type)      
      
      repeat{
        
        if (ncol(disease_filtered_gene_data)<=2) {
          elected_genes<-elected_genes_before
          disease_filtered_gene_data<-disease_filtered_gene_data_before
          specific_check_val<-1
        }
        
        if (ncol(disease_filtered_gene_data)>2 & specific_check_val==0) {
          elected_val<-NULL
          elected_genes<-greedy.wilks(tissue_type ~ ., data=disease_filtered_gene_data,niveau=niv_value)
          nameless_disease_filtered_gene_data<-disease_filtered_gene_data[,-1]
          elected_val<-elected_genes$results$vars
          elected_val<-as.vector(elected_val)
          
          
          if (length(elected_val)!=ncol(nameless_disease_filtered_gene_data)) {
            try(nameless_disease_filtered_gene_data<-nameless_disease_filtered_gene_data[,..elected_val],silent = TRUE)
            try(nameless_disease_filtered_gene_data<-nameless_disease_filtered_gene_data[,elected_val],silent = TRUE)
          }
        }
        
        disease_filtered_gene_data<-cbind(all_names,nameless_disease_filtered_gene_data)
        
        
        if (nrow(elected_genes$results)>2 ) {
          elected_genes_before<-elected_genes
          nameless_disease_filtered_gene_data_before<-nameless_disease_filtered_gene_data
          disease_filtered_gene_data_before<-disease_filtered_gene_data
        }
        
        skip_value<-1
        
        if (is.null(skip_value)==FALSE) {
          
          spl <- sample.split(disease_filtered_gene_data$tissue_type, SplitRatio = 0.80)
          training_set <- subset(disease_filtered_gene_data, spl == TRUE)
          test_set <- subset(disease_filtered_gene_data, spl == FALSE)
          row.names(training_set) <- NULL
          row.names(test_set) <- NULL
          
          if (is.null(train_test_val_check)==TRUE) {
            
            train_check<-training_set
            test_check<-test_set
            train_test_val_check<-1
          }
          
          if(is.null(para_fixer)==TRUE) {
            tuning_action<-tune.svm(as.factor(tissue_type)~., data=training_set,
                                          cost=10^(seq(-5,5,1)),gamma=10^(seq(-6,6,1)),scale=FALSE,probability=TRUE)
            svm_data<-tuning_action$best.model
          }
          
          
          check_training_set<-subset(training_set,select=-tissue_type)
          check_testing_set<-subset(test_set,select=-tissue_type)
          
          
          t_pred<-predict(svm_data,type="prob",check_training_set,probability =TRUE )
          y_pred <- predict(svm_data,type="prob", check_testing_set,probability =TRUE)
          
          
          train_table<-confusionMatrix(t_pred, as.factor(training_set$tissue_type))
          test_table<-confusionMatrix(y_pred,as.factor(test_set$tissue_type))
          
          test_spec<-test_table$byClass[2]
          train_spec<-train_table$byClass[2]
          train_sens<-train_table$byClass[1]
          
          test_pval<-test_table$overall[6]
          train_pval<-train_table$overall[6]
          test_kappa<-test_table$overall[2]
          train_kappa<-train_table$overall[2]
          
          
          if (train_spec>0.8 & train_kappa>0.8 & train_pval<0.05 & test_pval<0.05 & test_kappa>0.8 & test_spec>0.8) {
            
            final_elected_check<-elected_genes
            final_gene_list<-colnames(disease_filtered_gene_data[,-1])
            
            disease_filtered_gene_data<-cbind(all_names,actual_disease_filtered_gene_data)
            specific_check_val<-0
            para_fixer<-NULL
            elected_genes_before<-NULL
            nameless_disease_filtered_gene_data_before<-NULL
            disease_filtered_gene_data_before<-NULL
            
            if (test_pval<0.05) {
              if (final_elected_check$results$p.value.diff[length(final_elected_check$results$p.value.diff)]>0.05 & final_elected_check$results$p.value.diff[length(final_elected_check$results$p.value.diff)-1]<0.05) {
                final_gene_list<-as.data.frame(final_gene_list)
                colnames(final_gene_list)<-"Names"
                assign("final_discriminative_gene_set",final_gene_list,envir =.GlobalEnv)
                break}
              
              if (final_elected_check$results$p.value.diff[length(final_elected_check$results$p.value.diff)]<0.05) {
                final_gene_list<-as.data.frame(final_gene_list)
                colnames(final_gene_list)<-"Names"
                assign("final_discriminative_gene_set",final_gene_list,envir =.GlobalEnv)
                break}
            }
            niv_value<-niv_value-0.01
          }
          
        }
        skip_value<-NULL
        
        gc()
      }
    }
    
    if (exists("final_discriminative_gene_set")) {
      showModal(
        modalDialog(
          title = "Classification Analysis",
          "Process Completed. Visualize/Download Gene Sets in Results Section",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }else{
      showModal(
        modalDialog(
          title = "Error in Classification",
          "Missing DO Analysis Step",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
  })
}

#' @title SVMDO
#' @name gui_obj_removal_ui
#' @param id connection input
#' @return UI section of workspace clearance

innerUI_clear_env<- function(id){
  ns <- NS(id)
  actionButton(ns("clean_workspace"),"Clear Environment")
}

#' @title SVMDO
#' @name gui_obj_removal_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of workspace clearance


innerServer_9<-function(input,output,session){
  observeEvent(input$clean_workspace, {
    string_names_1<-c("complete_deg_gene_list","complete_deg_gene_list_test","disease_filtered_gene_data",
                    "final_discriminative_gene_set","new_tissue_type_list",
                    "sorted_new_bound_form_A","sorted_new_bound_form_A_test",
                    "sorted_new_bound_form_B", "sorted_new_bound_form_B_test",
                    "tcga_id_list","tcga_sample_comb","tissue_type_list",
                    "top_genes_test","top_genes","total_exp_dataset",
                    "total_exp_dataset_test","max_plots")
    
    n_list<-NULL
    y_list<-NULL
    sig_val<-NULL
    
    rm_var_names_1<-lapply(seq.int(string_names_1), function(i){
      if (exists(string_names_1[i],envir = .GlobalEnv )) {
        rm(list = c(string_names_1[i]), envir = .GlobalEnv)
        y_list<-c(0,y_list)
      }else{
        n_list<-c(1,n_list)
      }
      return(list(y_list=y_list,n_list=n_list))
      })
    
    if (all(names(table(unlist(rm_var_names_1), useNA="ifany")) %in% 1)) {
      y_list<-0
      n_list<-length(string_names_1)
    }else{
      y_list<-as.numeric(table(unlist(rm_var_names_1))[1])
      
      n_list<-as.numeric(table(unlist(rm_var_names_1))[2])

    }

    if(y_list==0){
      sig_val<-0
    }
    if(y_list>0){
      if ((n_list+y_list)==length(string_names_1)) {
        sig_val<-1
      }
    }
    
    if (length(ls(,pattern = "^fit1_",envir = .GlobalEnv))>0) {
      a<-length(ls(,pattern = "^fit1_",envir = .GlobalEnv))
      b<-ls(,pattern = "^fit1_",envir = .GlobalEnv)
      c<-ls(,pattern= "^modulename_",envir = .GlobalEnv)
      d<-ls(,pattern= "^p_",envir = .GlobalEnv)
      e<-ls(,pattern= "^hr_",envir = .GlobalEnv)
      rm_var_names_fit<-lapply(seq.int(a), function(i){
        rm(list = b[i], envir = .GlobalEnv)})
      rm_var_names_mod<-lapply(seq.int(a), function(i){
        rm(list = c[i], envir = .GlobalEnv)})
      rm_var_names_pval<-lapply(seq.int(a), function(i){
        rm(list = d[i], envir = .GlobalEnv)})
      rm_var_names_hr<-lapply(seq.int(a), function(i){
        rm(list = e[i], envir = .GlobalEnv)})
      }
    
    if (exists("plot_prep_sign",envir = .GlobalEnv )) {
      rm(list = c("fit_list","hr_list","p_list","modulename_list","plot_prep_sign"), envir = .GlobalEnv)
    }
    
    if (sig_val==1) {
      showModal(
        modalDialog(
          title = "Clearing SVMDO Objects",
          "Process Completed",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
    if(sig_val==0){
      showModal(
        modalDialog(
          title = "Error in SVMDO Objects",
          "Objects were not found",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
  })
}

#' @title SVMDO
#' @name classification_ui
#' @param id connection input
#' @return UI section of wilks lambda filtration and SVM classification of disease filtered differentially expressed gene set


innerUI_classification<- function(id){
  ns <- NS(id)
  actionButton(ns("initiate_wlsvmdo_analysis"),"Classification Analysis")
}

#' @title SVMDO
#' @name plot_show_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @param max_data Information of total number of survival plots prepared with discriminative gene set
#' @return Server section of providing information about total number of survival plots for visualization

plot_show_server<-function(input,output,session,max_data){
  
  output$plots<-renderUI({
    max_plot_val<-max_data()
    lapply(seq.int(max_plot_val),function(a) {
      local({
        plotname <- paste("plot", a, sep="")
        output[[plotname]] <- renderPlot({
          plot(get(fit_list[a]),main=get(modulename_list[a]),col = c(2,4),frame.plot=0,ylab="Survival Probability",xlab="Time (day)",cex.axis=1.5,cex.lab=1.5,cex.main=2)
          legend("top",legend = c("High risk group", "Low risk group"),text.col = c(2,4),bty = "n",horiz = TRUE,cex = 1.5)
          mtext(text = paste0("p = ",get(p_list[a])),side=3,adj = 1,line = -6,cex=1.5)
          mtext(text = paste0("HR = ",get(hr_list[a])),side=3,adj = 1,line = -8,cex = 1.5)
        },height = 500,width=500        
        )
      })
    })    
  })
}

#' @title SVMDO
#' @name survival_analysis_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @param rawData_2 Clinical data provided from clinic_data_input_server
#' @param rval Selected radio button information provided from innerServer_rad_server
#' @return Server section of survival analysis of final discriminative gene set


innerServer_8<-function(input,output,session,rawData_2,rval) {
  observeEvent(input$initiate_surv_analysis, {
    surv_object<-NULL                          
    st_point<-NULL
    end_point<-NULL
    exp_col_data<-NULL
    coxcoeff<-NULL
    rval_sel<-rval()
    
    if (exists("tcga_sample_comb") & exists("final_discriminative_gene_set")) {
      exp_col_data<-tcga_sample_comb$id
      
      if (exists("top_genes_test")) {
        exp_data<-top_genes_test
      }else{
        exp_data<-top_genes
      }
      
      st_point<-as.numeric(sum(tcga_sample_comb$tissue_type=="normal")+1)
      end_point<-as.numeric(sum(tcga_sample_comb$tissue_type=="normal")+sum(tcga_sample_comb$tissue_type=="tumour"))
      exp_col_data<-tcga_sample_comb$id
      tcga_sample_comb<-tcga_sample_comb[tcga_sample_comb$tissue_type=="tumour",]
      
      exp_data<-as.data.frame(t(exp_data))
      colnames(exp_data)<-exp_col_data
      
      V1<-rownames(exp_data)
      exp_data<-exp_data[,seq.int(st_point,end_point)]
      exp_data<-cbind(V1,exp_data)
      
      colnames(exp_data)<-c("V1",as.character(tcga_sample_comb$id))
      rownames(exp_data)<-NULL
      
      disc_list<-final_discriminative_gene_set
      
      if (rval_sel=="COAD") {
        package_path<-find.package("SVMDO",quiet=TRUE)
        rds_path<-"extdata/coad_clinic_sum.rds"
        comb_path<-file.path(package_path,rds_path,fsep = "/")
        c<-readRDS(comb_path)
        alldata<-assay(c)
      }else if (rval_sel=="LUSC"){
        package_path<-find.package("SVMDO",quiet=TRUE)
        rds_path<-"extdata/lusc_clinic_sum.rds"
        comb_path<-file.path(package_path,rds_path,fsep = "/")
        c<-readRDS(comb_path)
        alldata<-assay(c)
      }else{
        alldata<-rawData_2()
      }
      
      if (ncol(alldata)<5 & colnames(alldata)[3]=="vital_status") {
        alldata[alldata == "--"] <- NA
        alldata[alldata == ""] <- NA
        alldata$days_to_death <- as.numeric(as.character(alldata$days_to_death))
        alldata$vital_status <- as.character(alldata$vital_status)
        alldata$vital_status[alldata$vital_status == "Alive"] <- 1
        alldata$vital_status[alldata$vital_status == "Dead"] <- 2
        alldata$vital_status <- as.numeric(as.character(alldata$vital_status))
        alldata$id <- as.character(gsub("-", ".", alldata$id, fixed = TRUE))
        
        exp_data<-exp_data[,(names(exp_data) %in% as.factor(alldata$id))]
        exp_data<-cbind(V1,exp_data)
        
        sub_exp_data<-exp_data[exp_data$V1 %in% disc_list$Names,]
        sub_exp_data<-as.data.frame(sub_exp_data)
        rownames(sub_exp_data)<-NULL
        
        table1 <- data.frame(matrix(NA, nrow = length(disc_list$Names), ncol = 5))
        colnames(table1) <- c("modulename", "p", "hr", "low", "up")
        
        name_data<-final_discriminative_gene_set$Names
        
        prog_prep<-lapply(seq_along(disc_list$Names),function(a){
          alldata1 <- alldata
          module <- (sub_exp_data[a,])
          row.names(module) <- make.names(module[,1], unique = TRUE)
          module <- (module[,-1])
          
          moduletrans <- as.data.frame(t(module))
          name_val<-colnames(moduletrans)
          
          moduletrans<-as.data.frame(moduletrans[match(alldata1$id,rownames(moduletrans)),])
          colnames(moduletrans)<-name_val
          
          coxcoeff<- coxph(Surv(time= alldata1$days_to_death, event = alldata1$vital_status) ~ (moduletrans[,1]), data = alldata1)$coefficients
          PI <- data.frame()[seq.int(1,nrow(moduletrans)),]
          
          lap_PI_test<-lapply(seq.int(nrow(moduletrans)), function(b){
            pi_val<-sum(na.omit(((moduletrans[b,])) * coxcoeff))
          })
          
          PI<-as.data.frame(unlist(lap_PI_test))
          rownames(PI) <- rownames(moduletrans)
          colnames(PI) <- 'PI'
          
          alldata1 <- mutate(alldata1, PI = PI$PI)
          medPI <- median(PI$PI)
          
          if (medPI<=0 ) {
            
            if (sum(PI$PI<=0)==nrow(alldata1)) {
              alldata1$group <- ifelse(PI$PI < medPI, 2, 1)
            }
            
            if (sum(PI$PI>=0)==nrow(alldata1)) {
              alldata1$group <- ifelse(PI$PI <= medPI, 2, 1)
            }
          }
          
          if (medPI>0) {
            alldata1$group <- ifelse(PI$PI <= medPI, 2, 1)
          }
          
          if (sum(!duplicated(alldata1$group))!=1) {
            
            surv_object <- Surv(time = alldata1$days_to_death, event = alldata1$vital_status)
            fit1 <- survfit(surv_object ~ group, data = alldata1)
            coxhr <- coxph(surv_object ~ group, data = alldata1)
            summhr <- summary(coxhr)
            p <- round(summhr$sctest[3], digits = 5)
            
            
            data.survdiff <- survdiff(surv_object ~ group, data = alldata1)
            hr = round((data.survdiff$obs[1]/data.survdiff$exp[1])/(data.survdiff$obs[2]/data.survdiff$exp[2]), digits = 3)
            up = round(exp(log(hr) + qnorm(0.975)*sqrt(1/data.survdiff$exp[2]+1/data.survdiff$exp[1])), digits = 3)
            low = round(exp(log(hr) - qnorm(0.975)*sqrt(1/data.survdiff$exp[2]+1/data.survdiff$exp[1])), digits = 3)
            
            modulename <- (sub_exp_data$V1[a])
            if (str_contains(modulename,"__")) {
              modulename<-gsub("__","-",modulename)
            }
            
            if (p<0.05) {
              assign(paste0("fit1","_",a),fit1,envir = .GlobalEnv)
              assign(paste0("modulename","_",a),modulename,envir = .GlobalEnv)
              assign(paste0("hr","_",a),hr,envir = .GlobalEnv)
              assign(paste0("p","_",a),p,envir = .GlobalEnv)
            }
          }
          
          
          showModal(
            modalDialog(
              title = "Survival Analysis",
              "Process Completed. Visualize/Download Survival Plots in Results Section",
              easyClose = TRUE,
              footer = NULL
            )
          )
          
        })
        
        
      }else{
        showModal(
          modalDialog(
            title = "Detecting Dataset Incompatibility",
            "Please Check Manual (Vignette) for Clinical Dataset Preparation",
            easyClose = TRUE,
            footer = NULL
          )
        )
      }
      

    }else{
      showModal(
        modalDialog(
          title = "Error in Survival Analysis",
          "Missing Classification Step",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
  })
}

#' @title SVMDO
#' @name disc_gene_dw_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @param gene_list_val discriminative gene set list variable
#' @return Server section of discriminative gene set download button

disc_gene_dw_server<-function(input,output,session,gene_list_val){
  observeEvent(input$dw_genes, {
    if(exists("final_discriminative_gene_set")){
      gene_name_variable<-gene_list_val()
      if ((gene_name_variable)!="") {
        path_loc<-file.path(direct_val_gene_list,"/",gene_name_variable,".txt",fsep="")
        write.table(final_discriminative_gene_set,file = path_loc,sep = "\t")
        showModal(
          modalDialog(
            title = "Gene List Download Completed",
            paste("Save Location:",sep=" ",direct_val_gene_list),
            easyClose = TRUE,
            footer = NULL
          )
        )
      }else{
        showModal(
          modalDialog(
            title = "Filename Error",
            "Please Enter Filename",
            easyClose = TRUE,
            footer = NULL
          )
        )
      }
    }else{
      showModal(
        modalDialog(
          title = "Gene List Download Failed",
          "Missing Gene List Data",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
  })
  
}

#' @title SVMDO
#' @name surv_plot_dw_ui
#' @param id connection input
#' @return UI section of downloading survival plots of discriminative gene set

surv_plots_download_ui<-function(id){
  ns<-NS(id)
  actionButton(ns("dw_plots"),"Download Survival Plot List")
}

#' @title SVMDO
#' @name plot_push_ui
#' @param id connection input
#' @return UI section of providing information about total number of survival plots for visualization


innerUI_plot_inject<-function(id){
  ns <- NS(id)
  actionButton(ns("plot_add"),"Show Survival Plot List")  
}

#' @title SVMDO
#' @name top_val_ui
#' @param id connection input
#' @return UI section of entering top gene value


innerUI_top_gene_val <- function(id) {
  ns <- NS(id)
  fluidRow(
    column(4,      
           numericInput(ns("num_val"),"Input Size (Fixed for Test Datasets)", value = 50,min = 50)))
}

#' @title SVMDO
#' @name table_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of providing discriminative gene set for preparing table

table_server<-function(input,output,session){
  getData<-eventReactive(input$file,{
    if (exists("final_discriminative_gene_set")) {
      final_discriminative_gene_set
    }else{
      showModal(
        modalDialog(
          title = "Error in Gene Set Visualization",
          "Classification Step is Missing",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
  })
}

#' @title SVMDO
#' @name clinic_data_input_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of loading clinical data 

# Clinical dataset to be used in survival analysis consists of 3 main columns:
# TCGA id
# Patient Days to Death Information 
# Patient Vital Status (Death/Alive)

innerServer_clinic <- function(input, output, session) {
  rawData_2 <- eventReactive(input$file2, {read.table(input$file2$datapath,sep = "\t",header = TRUE)})
  return(rawData_2)
}

#' @title SVMDO
#' @name plot_list_ui
#' @param id connection output
#' @return UI section of preparing plot list to be visualized in GUI page

innerUI_collect_plot_data<-function(id){
  ns <- NS(id)
  actionButton(ns("list_data"),"Prepare Survival Plot List")
}

#' @title SVMDO
#' @name gene_directory_selection_ui
#' @param id connection input
#' @return UI section of entering output/working for gene list directory

innerUI_path <- function(id) {
  ns <- NS(id)
  fluidRow(
    column(5,
           shinyDirButton(ns("dir"), "Choose Output Directory", ns("Upload")),
           verbatimTextOutput(ns("dir"), placeholder = TRUE)))
}

#' @title SVMDO
#' @name plot_push_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of providing information about total number of survival plots for visualization

plot_push_server<-function(input,output,session){
  max_data<-eventReactive(input$plot_add,{
    max_plots
  })
  return(max_data)
}

#' @title SVMDO
#' @name surv_plot_dw_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of downloading survival plots of discriminative gene set


surv_plot_dw_server<-function(input,output,session){
  observeEvent(input$dw_plots,{
    if(exists("final_discriminative_gene_set") & exists("modulename_list")){
      lapply(seq.int(length(fit_list)),function(a){
        png(filename=file.path(direct_val_gene_list,"/",get(modulename_list[a]),".png",fsep = ""),width = 800,height = 600)
        plot(get(fit_list[a]),main=get(modulename_list[a]),col = c(2,4),frame.plot=0,ylab="Survival Probability",xlab="Time (day)",cex.axis=1.5,cex.lab=1.5,cex.main=2)
        legend("top",legend = c("High risk group", "Low risk group"),text.col = c(2,4),bty = "n",horiz = TRUE,cex = 1.5)
        mtext(text = paste0("p = ",get(p_list[a])),side=3,adj = 1,line = -6,cex=1.5)
        mtext(text = paste0("HR = ",get(hr_list[a])),side=3,adj = 1,line = -8,cex = 1.5)
        dev.off()})
      showModal(
        modalDialog(
          title = "Plot List Download Completed",
          paste("Save Location:",sep=" ",direct_val_gene_list),
          easyClose = TRUE,
          footer = NULL
        )
      )
      
    }else{
      showModal(
        modalDialog(
          title = "Survival Plot List Download Failed",
          "Plot List Not Found",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
  })
}

#' @title SVMDO
#' @name expression_dataset_input_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of providing expression dataset

# Expression dataset to be used in DEG analysis consists of 3 main columns:
# TCGA id
# Tissue type (Normal/Tumour)
# Expression values (Named with Gene Symbols)

# If there is not any requirements for survival analysis, TCGA id is not required

innerServer_exp <- function(input, output, session) {
  rawData <- eventReactive(input$file1, {
    fread(input$file1$datapath,sep = "\t")
    })
  return(rawData)
  
}

#' @title SVMDO
#' @name disc_gene_download_ui
#' @param id connection input
#' @return UI section of discriminative gene set download button

disc_gene_download_ui<- function(id){
  ns <- NS(id)
  actionButton(ns("dw_genes"),"Download Gene List")
}

#' @title SVMDO
#' @name plot_list_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of preparing plot list to be visualized in GUI page

plot_list_server<-function(input,output,session){
  observeEvent(input$list_data, {
    
    if (length(ls(pattern = "^fit1_",envir = .GlobalEnv))>0) {
      fit_list<-ls(pattern = "^fit1_",envir = .GlobalEnv)

      modulename_list<-ls(pattern = "modulename_",envir = .GlobalEnv)
      p_list<-ls(pattern = "^p_",envir = .GlobalEnv)
      hr_list<-ls(pattern = "^hr_",envir = .GlobalEnv)
      
      assign("fit_list",fit_list,envir = .GlobalEnv)
      assign("modulename_list",modulename_list,envir = .GlobalEnv)
      assign("hr_list",hr_list,envir = .GlobalEnv)
      assign("p_list",p_list,envir = .GlobalEnv)
      assign("max_plots",length(fit_list),envir = .GlobalEnv)
      assign("plot_prep_sign",1,envir = .GlobalEnv)
      
      showModal(
        modalDialog(
          title = "Survival Plot Preparation",
          "Process Completed",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }else{
      showModal(
        modalDialog(
          title = "Survival Plot Preparation",
          "Missing Survival Plots",
          easyClose = TRUE,
          footer = NULL
        )
      )
    }
    })}

#' @title SVMDO
#' @name gene_list_name_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of entering final gene list name 

innerServer_10<-function(input, output, session) {
  gene_list_val <- reactive({input$gene_names})
  return(gene_list_val)
}

#' @title SVMDO
#' @name package_req_list
#' @return List of packages involved in SVMDO

if (!requireNamespace("nortest", quietly = TRUE))
  stop("Install 'nortest' to use this package.")

if (!requireNamespace("e1071", quietly = TRUE))
  stop("Install 'e1071' to use this package.")

if (!requireNamespace("BSDA", quietly = TRUE))
  stop("Install 'BSDA' to use this package.")

if (!requireNamespace("data.table", quietly = TRUE))
  stop("Install 'data.table' to use this package.")

if (!requireNamespace("DT", quietly = TRUE))
  stop("Install 'DT' to use this package.")

if (!requireNamespace("sjmisc", quietly = TRUE))
  stop("Install 'sjmisc'  to use this package.")

if (!requireNamespace("klaR", quietly = TRUE))
  stop("Install 'klaR' to use this package.")

if (!requireNamespace("DT", quietly = TRUE))
  stop("Install 'DT' to use this package.")

if (!requireNamespace("caTools", quietly = TRUE))
  stop("Install 'caTools' to use this package.")

if (!requireNamespace("caret", quietly = TRUE))
  stop("Install 'caret' to use this package.")

if (!requireNamespace("survival", quietly = TRUE))
  stop("Install 'survival' to use this package.")

if (!requireNamespace("DOSE", quietly = TRUE))
  stop("Install 'DOSE' to use this package.")

if (!requireNamespace("AnnotationDbi", quietly = TRUE))
  stop("Install 'AnnotationDbi' to use this package.")

if (!requireNamespace("org.Hs.eg.db", quietly = TRUE))
  stop("Install 'org.Hs.eg.db' to use this package.")

if (!requireNamespace("dplyr", quietly = TRUE))
  stop("Install 'dplyr' to use this package.")

if (!requireNamespace("shiny", quietly = TRUE))
  stop("Install 'shiny' to use this package.")

if (!requireNamespace("shinytitle", quietly = TRUE))
  stop("Install 'shinytitle' to use this package.")

if (!requireNamespace("shinyFiles", quietly = TRUE))
  stop("Install 'shinyFiles' to use this package.")

if (!requireNamespace("golem", quietly = TRUE))
  stop("Install 'golem' to use this package.")

#' @title SVMDO
#' @name globals
#' @return Including script files and global variables of GUI required to be 
#' initiated at the runApp file execution


source(file.path('R/table_server.R'))
source(file.path('R/table_ui.R'))

source(file.path('R/disc_gene_dw_server.R'))
source(file.path('R/disc_gene_dw_ui.R'))

source(file.path('R/gene_directory_selection_server.R'))
source(file.path('R/gene_directory_selection_ui.R'))

source(file.path('R/expression_dataset_input_server.R'))
source(file.path('R/expression_dataset_input_ui.R'))

source(file.path('R/test_data_selection_server.R'))
source(file.path('R/test_data_selection_ui.R'))

source(file.path('R/clinic_data_input_server.R'))
source(file.path('R/clinic_data_input_ui.R'))

source(file.path('R/disc_gene_dw_server.R'))
source(file.path('R/disc_gene_dw_ui.R'))

source(file.path('R/plot_list_server.R'))
source(file.path('R/plot_list_ui.R'))

source(file.path('R/plot_push_server.R'))
source(file.path('R/plot_push_ui.R'))

source(file.path('R/plot_show_server.R'))
source(file.path('R/plot_show_ui.R'))

source(file.path('R/surv_plot_dw_server.R'))
source(file.path('R/surv_plot_dw_ui.R'))

source(file.path('R/gene_list_table_visualization_ui.R'))
source(file.path('R/package_req_list.R'))

source(file.path('R/deg_server.R'))
source(file.path('R/deg_ui.R'))

source(file.path('R/top_val_server.R'))
source(file.path('R/top_val_ui.R'))

source(file.path('R/top_val_based_deg_filtration_server.R'))
source(file.path('R/top_val_based_deg_filtration_ui.R'))

source(file.path('R/do_based_gene_filtration_server.R'))
source(file.path('R/do_based_gene_filtration_ui.R'))

source(file.path('R/classification_server.R'))
source(file.path('R/classification_ui.R'))

source(file.path('R/survival_analysis_server.R'))
source(file.path('R/survival_analysis_ui.R'))

source(file.path('R/gui_obj_removal_server.R'))
source(file.path('R/gui_obj_removal_ui.R'))

globalVariables(c("final_discriminative_gene_set","direct_val_gene_list","gene_list_val","top_genes","tcga_id_list", 
                  "sorted_new_bound_form_A","sorted_new_bound_form_B", "hr_list",
                  "fit1_val","max_plots","fit_list","modulename_list","p_list",
                  "..elected_val","..num_data", 
                  "..type_num_data","tissue_type_list","disease_filtered_gene_data",
                  "tcga_sample_comb","new_tissue_type_list","tissue_type",
                  "top_genes_test","total_exp_dataset","c_path",
                  "sorted_new_bound_form_A_test","sorted_new_bound_form_B_test",
                  "top_combined_genes"))

#' @title SVMDO
#' @name gene_list_name_ui
#' @param id connection input
#' @return UI section of entering top gene value


innerUI_gene_names <- function(id) {
  ns <- NS(id)
  fluidRow(
    column(8,      
           textInput(ns("gene_names"),"Enter Final Gene Set Filename")))
}

#' @title SVMDO
#' @return Providing package-level manual page
#' 
#' @description Package Description:
#' It is an easy-to-use GUI using disease information for detecting 
# 'tumor/normal sample discriminating gene sets from differentially 
#' expressed genes. Our approach is based on an iterative algorithm 
#' filtering genes with disease ontology enrichment analysis and wilk 
#' and wilks lambda criterion connected to SVM classification model 
#' construction. Along with gene set extraction, SVMDO also provides 
#' individual prognostic marker detection. The algorithm is designed 
#' for FPKM and RPKM normalized RNA-Seq transcriptome datasets. 

#' @title SVMDO
#' @name deg_ui
#' @param id connection input

#' @return UI section of differential gene expression analysis

innerUI_deg_analysis <- function(id) {
  ns <- NS(id)
  fluidRow(
    column(1,      
           actionButton(ns("initiate_deg_analysis"), "DEG Analysis")))
}

#' @title SVMDO
#' @name top_val_based_deg_filtration_ui
#' @param id connection input
#' @return UI section of selecting differentially expressed genes based on top gene value

innerUI_top_gene_selection <- function(id) {
  ns <- NS(id)
  fluidRow(
    column(1,      
           actionButton(ns("initiate_top_gene_selection"),"Top Gene Number Selection")))
}

# First of all, assign your dataset to a variable (dataset has to be in txt form)

# Assume that, variable name is "x", tab-separated and first line is header

# x<-read.table("dataset_name.txt",sep="\t",header=TRUE)

# To create SummarizedExperiment object, SummarizedExperiment() function from the
# SummarizedExperiment Bioconductor package is used

# Assume that a variable named as "sum_data" is used for SummarizedExperiment object creation

# library(SummarizedExperiment)
# sum_data<-SummarizedExperiment(x)

# To save your object into a rda file, use saveRDS() base function

# Assume that rda file is named as prep_sum_data

# saveRDS(sum_data,file="prep_sum_data")

#' @title SVMDO
#' @name top_val_based_deg_filtration
#' @param input server input
#' @param output server output
#' @param session server session
#' @param top_val top gene number value provided from top_val_server
#' @return Server section of selecting differentially expressed genes based on top gene value

innerServer_5<- function(input,output,session,top_val){
  observeEvent(input$initiate_top_gene_selection, {
    top_gene_selection<-NULL
    top_gene_number<-top_val()

    if (exists("sorted_new_bound_form_A")) {
      
      if (nrow(sorted_new_bound_form_A) < top_gene_number | nrow(sorted_new_bound_form_B) < top_gene_number) {
        max_down_genes<-sorted_new_bound_form_A
        max_up_genes<-sorted_new_bound_form_B
        message("Insufficient gene number All up/downregulated genes were selected")
        message("Enter a lower value of input size")
      }else{
        max_down_genes<-sorted_new_bound_form_A[seq.int((nrow(sorted_new_bound_form_A)-(top_gene_number-1)),nrow(sorted_new_bound_form_A)),]
        max_up_genes<-sorted_new_bound_form_B[seq.int((nrow(sorted_new_bound_form_B)-(top_gene_number-1)),nrow(sorted_new_bound_form_B)),]
      }
      top_combined_genes<-rbind(max_down_genes,max_up_genes)
      rownames(top_combined_genes)<-top_combined_genes[,1]
      changed_whole_data<-subset(total_exp_dataset,select=top_combined_genes$Genes)
      assign("top_genes",changed_whole_data,envir =.GlobalEnv)
      top_gene_selection<-1
    }else{
      showModal(
        modalDialog(
          title = "Error in Top Gene Selection",
          "Missing DEG Analysis Step",
          easyClose = TRUE,footer = NULL))}
    
    if (!is.null(top_gene_selection)) {
      showModal(
        modalDialog(
          title = "Top Gene Selection",
          "Process Completed",
          easyClose = TRUE,footer = NULL))}
  })
}

#' @title SVMDO
#' @name runGUI
#' @param n linebreak function variable
#' @return Returning GUI window screen
#' 
#' @importFrom shinyFiles shinyDirChoose shinyDirButton getVolumes
#' @importFrom golem with_golem_options
#' @import shiny
#' @importFrom shinytitle use_shiny_title
#' @importFrom nortest ad.test
#' @importFrom SummarizedExperiment assay
#' @importFrom e1071 svm tune.svm
#' @importFrom BSDA z.test
#' @importFrom data.table fread fwrite first
#' @importFrom sjmisc str_contains
#' @importFrom caTools sample.split
#' @importFrom klaR greedy.wilks
#' @importFrom DT DTOutput renderDT
#' @importFrom caret confusionMatrix
#' @importFrom survival Surv survfit coxph survdiff
#' @importFrom DOSE enrichDO
#' @importFrom AnnotationDbi select
#' @importFrom org.Hs.eg.db org.Hs.eg.db
#' @importFrom dplyr mutate
#' @importFrom grDevices dev.off png
#' @importFrom graphics legend mtext
#' @importFrom stats median na.omit p.adjust predict qnorm sd wilcox.test
#' @importFrom utils read.table write.table

#' @examples
#' #SVMDO::runGUI() Calling GUI without activating library
#' #runGUI() Calling GUI after activating library
#' # Disease Ontology Enrichment of a differentially expresed gene (entrez id):
#' a_1<-DOSE::enrichDO(2981,ont="HDO")

linebreaks <- function(n){HTML(strrep(br(), n))}

outerUI <- function(id) {
  
  ns <- NS(id)
  
  navbarPage(title="SVMDO",
             tabPanel(title = "Analysis",
                      column(6,
                      fluidRow(
                        column(12,
                               wellPanel(
                                 linebreaks(1),
                                 helpText(a("Click here to examine recent version of SVMDO manual in Github", 
                                            target="_blank",
                                            href="https://github.com/robogeno/SVMDO/blob/master/vignettes/SVMDO_guide.Rmd")),
                                 p("(Results of classification and survival analyses can be visualized and/or downloaded in 'Result' Section)"),
                                 p("(Wait until 'Upload complete' message appears after choosing your expression dataset)"),
                                 innerUI_exp_data(ns("inner2")),
                                 p("(In a test study, clinical and expression datasets are pre-selected)"),
                                 innerUI_test_data(ns("inner3")),
                                 p("(In an input-based differential expression analysis, an error message will appear if expression dataset is incompatible)"),
                                 innerUI_deg_analysis(ns("inner4")),
                                 linebreaks(1),
                                 innerUI_top_gene_val(ns("inner5")),
                                 innerUI_top_gene_selection(ns("inner6")),
                                 linebreaks(1),
                                 div(style="display:inline-block",
                                     innerUI_disease_ont_class(ns("inner7")),
                                     innerUI_classification(ns("inner8")
                                                            )),
                                 linebreaks(1),
                                 innerUI_clinic_data(ns("inner9")),
                                 p("(In an input-based survival analysis, incompatible clinical dataset will result in an error message)"),
                                 div(style="display:inline-block",
                                     innerUI_surv(ns("inner10")),
                                     innerUI_clear_env(ns("inner11")))
                                 ))
                                 
                               )),
                      ),
             tabPanel(title = "Results",
                      fluidRow(column(6,
                                      p("(Visualizing the gene set acquired from classification step)"),
                                      innerUI_table_show(ns("inner12")),
                                      div(DTOutput(ns("table")), 
                                      style = "font-size: 60%;width: 50%"),
                                      div(style="display:inline-block",
                                          p("(To download or show plots, click on Prepare Survival Plot List button)"),
                                          innerUI_collect_plot_data(ns("inner13")),
                                          div(linebreaks(1),
                                              p("(Output directory of final gene set and survival plots)"),
                                              p("(To download them in different directories, it can be used sequentially)"),
                                              innerUI_path(ns("inner1"))),
                                          innerUI_gene_names(ns("inner18")),
                                          disc_gene_download_ui(ns("inner14")),
                                          surv_plots_download_ui(ns("inner15")),
                                          innerUI_plot_inject(ns("inner16")),
                                          innerUI_plot_show(ns("inner17")))
                                      ))))}

ui <- fluidPage(
  outerUI("mod1")
)

outerServer <- function(id) {
  moduleServer(
    id,
    function(input, output, session) {
      innerResult <- callModule(innerServer,"inner1")
      innerResult_2 <-callModule(innerServer_exp, "inner2")
      innerResult_x <- callModule(innerServer_rad,"inner3")
      innerResult_3 <- callModule(innerServer_3, "inner4",innerResult_2,innerResult_x)
      innerResult_4 <- callModule(innerServer_4, "inner5")
      innerResult_5 <- callModule(innerServer_5, "inner6",innerResult_4)
      innerResult_6 <- callModule(innerServer_6, "inner7")
      innerResult_7 <- callModule(innerServer_7, "inner8")
      innerResult_clinic <- callModule(innerServer_clinic,"inner9")
      innerResult_8 <- callModule(innerServer_8, "inner10",innerResult_clinic,innerResult_x)
      innerResult_9 <- callModule(innerServer_9,"inner11")
      innerResult_10<-callModule(table_server,"inner12")
      output$table<-renderDT(return(innerResult_10()),options = list(pageLength = 5)
                                           ,escape=FALSE)
      innerResult_11<-callModule(plot_list_server,"inner13")
      innerResult_16<-callModule(innerServer_10,"inner18")    
      innerResult_12<-callModule(disc_gene_dw_server,"inner14",innerResult_16)
      innerResult_13<-callModule(surv_plot_dw_server,"inner15")
      innerResult_14<-callModule(plot_push_server,"inner16")
      innerResult_15<-callModule(plot_show_server,"inner17",innerResult_14)
      }
  )
}

server <- function(input, output, session) {
  outerServer("mod1")
  session$onSessionEnded(function() {
    stopApp()
  })
}

#' @export

runGUI <- function(
    reproducible = TRUE
) {
  options(shiny.maxRequestSize = 700*1024^2)
  with_golem_options(
    app = shinyApp(
      ui = ui, 
      server = server,
      options = list("launch.browser"=TRUE)
    ),
    golem_opts = list(reproducible = reproducible)
  )
}

#' @title SVMDO
#' @name test_data_selection_ui
#' @param id connection input
#' @return UI section of providing information about selected radio button 

innerUI_test_data <- function(id) {
  ns <- NS(id)
  fluidRow(
    column(4,radioButtons(ns("test_datasets"),"Load Test Datasets (DEG + Survival)",
                          choices = c("None","COAD","LUSC"))))
}

#' @title SVMDO
#' @name test_data_selection_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of providing information about selected radio button 

innerServer_rad<-function(input, output, session) {
  rval <- reactive({input$test_datasets})
  return(rval)
}

#' @title SVMDO
#' @name plot_show_ui
#' @param id connection input
#' @return UI section of providing information about total number of survival plots for visualization


innerUI_plot_show<-function(id){
  ns <- NS(id)
  uiOutput(outputId = ns("plots"))
}

#' @title SVMDO
#' @name gene_directory_selection_server
#' @param input server input
#' @param output server output
#' @param session server session
#' @return Server section of entering output/working for gene list directory


innerServer <- function(input, output,session) {
  if (grepl("linux-gnu", R.version$os)) {
    osSystem<-"Linux"
  }else{
    osSystem<-R.version$os
  }
  if (osSystem == "Linux") {
    def_roots <- c(home = "~")
  }else {
    def_roots <- getVolumes()()
  }
  shinyDirChoose(
    input,
    'dir',
    roots=def_roots,
    filetypes = c("txt")
  )
  
  global <- reactiveValues(datapath=getwd())
  dir <- reactive(input$dir)
  output$dir <- renderText({
    global$datapath
  })
  
  assign("direct_val_gene_list",getwd(), envir =.GlobalEnv)
  
  observeEvent(ignoreNULL = TRUE,
               eventExpr = {
                 input$dir
               },
               handlerExpr = {
                 if (!"path" %in% names(dir())) return()
                 home <- normalizePath("~")
                 global$datapath <-file.path(home, paste(unlist(dir()$path[-1]), collapse = .Platform$file.sep))
                 if (osSystem == "Linux") {
                   filtered<-gsub("^[^/]*/", "", global$datapath)
                   assign("direct_val_gene_list",global$datapath, envir =.GlobalEnv)
                 }else{
                   filtered<-gsub("^[^/]*/", "", global$datapath)
                   selected_dir_val<-file.path(as.character(def_roots),filtered,fsep = "/")
                   global$datapath<-selected_dir_val
                   assign("direct_val_gene_list",global$datapath, envir =.GlobalEnv)

                   
                 }})

  
}

test_that("Prognostic Analysis is succesful", {
  
  c_path<-system.file("extdata","coad_clinic_sum.rds",package="SVMDO",mustWork = TRUE)
  c<-readRDS(c_path)
  alldata<-assay(c)
  
  surv_object<-NULL                          
  st_point<-NULL
  end_point<-NULL
  exp_col_data<-NULL
  coxcoeff<-NULL
  
  exp_col_data<-tcga_sample_comb$id
  
  exp_data<-top_genes
  
  st_point<-as.numeric(sum(tcga_sample_comb$tissue_type=="normal")+1)
  end_point<-as.numeric(sum(tcga_sample_comb$tissue_type=="normal")+sum(tcga_sample_comb$tissue_type=="tumour"))
  exp_col_data<-tcga_sample_comb$id
  tcga_sample_comb<-tcga_sample_comb[tcga_sample_comb$tissue_type=="tumour",]
  
  exp_data<-as.data.frame(t(exp_data))
  colnames(exp_data)<-exp_col_data
  
  V1<-rownames(exp_data)
  exp_data<-exp_data[,st_point:end_point]
  exp_data<-cbind(V1,exp_data)
  
  colnames(exp_data)<-c("V1",as.character(tcga_sample_comb$id))
  rownames(exp_data)<-NULL
  
  disc_list<-final_discriminative_gene_set
  

  alldata[alldata == "--"] <- NA
  alldata[alldata == ""] <- NA
  alldata$days_to_death <- as.numeric(as.character(alldata$days_to_death))
  alldata$vital_status <- as.character(alldata$vital_status)
  alldata$vital_status[alldata$vital_status == "Alive"] <- 1
  alldata$vital_status[alldata$vital_status == "Dead"] <- 2
  alldata$vital_status <- as.numeric(as.character(alldata$vital_status))
  alldata$id <- as.character(gsub("-", ".", alldata$id, fixed = TRUE))
  
  exp_data<-exp_data[,(names(exp_data) %in% as.factor(alldata$id))]
  exp_data<-cbind(V1,exp_data)
  
  sub_exp_data<-exp_data[exp_data$V1 %in% disc_list$Names,]
  sub_exp_data<-as.data.frame(sub_exp_data)
  rownames(sub_exp_data)<-NULL
  
  table1 <- data.frame(matrix(NA, nrow = length(disc_list$Names), ncol = 5))
  colnames(table1) <- c("modulename", "p", "hr", "low", "up")
  
  name_data<-final_discriminative_gene_set$Names
  prog_prep<-lapply(seq_along(disc_list$Names),function(a){
  alldata1 <- alldata
  
  module <- (sub_exp_data[a,])
  row.names(module) <- make.names(module[,1], unique = TRUE)
  module <- (module[,-1])
  
  moduletrans <- as.data.frame(t(module))
  name_val<-colnames(moduletrans)
  
  moduletrans<-as.data.frame(moduletrans[match(alldata1$id,rownames(moduletrans)),])
  colnames(moduletrans)<-name_val
  
  coxcoeff<- coxph(Surv(time= alldata1$days_to_death, event = alldata1$vital_status) ~ (moduletrans[,1]), data = alldata1)$coefficients
  PI <- data.frame()[seq.int(1,nrow(moduletrans)),]
  
  lap_PI_test<-lapply(seq.int(nrow(moduletrans)), function(b){
    pi_val<-sum(na.omit(((moduletrans[b,])) * coxcoeff))
  })
  
  PI<-as.data.frame(unlist(lap_PI_test))
  rownames(PI) <- rownames(moduletrans)
  colnames(PI) <- 'PI'
  
  alldata1 <- mutate(alldata1, PI = PI$PI)
  medPI <- median(PI$PI)
  
  if (medPI<=0 ) {
    
    if (sum(PI$PI<=0)==nrow(alldata1)) {
      alldata1$group <- ifelse(PI$PI < medPI, 2, 1)
    }
    
    if (sum(PI$PI>=0)==nrow(alldata1)) {
      alldata1$group <- ifelse(PI$PI <= medPI, 2, 1)
    }
  }
  
  if (medPI>0) {
    alldata1$group <- ifelse(PI$PI <= medPI, 2, 1)
  }
  
  if (sum(!duplicated(alldata1$group))!=1) {    
    surv_object <- Surv(time = alldata1$days_to_death, event = alldata1$vital_status)
    fit1 <- survfit(surv_object ~ group, data = alldata1)
    coxhr <- coxph(surv_object ~ group, data = alldata1)
    summhr <- summary(coxhr)
    p <- round(summhr$sctest[3], digits = 5)    
    
    data.survdiff <- survdiff(surv_object ~ group, data = alldata1)
    hr = round((data.survdiff$obs[1]/data.survdiff$exp[1])/(data.survdiff$obs[2]/data.survdiff$exp[2]), digits = 3)
    up = round(exp(log(hr) + qnorm(0.975)*sqrt(1/data.survdiff$exp[2]+1/data.survdiff$exp[1])), digits = 3)
    low = round(exp(log(hr) - qnorm(0.975)*sqrt(1/data.survdiff$exp[2]+1/data.survdiff$exp[1])), digits = 3)
    
    modulename <- (sub_exp_data$V1[a])
    if (str_contains(modulename,"__")) {
      modulename<-gsub("__","-",modulename)
    }
    
    if (p<0.05) {
      assign(paste0("fit1","_",a),fit1,envir = .GlobalEnv)
      assign(paste0("modulename","_",a),modulename,envir = .GlobalEnv)
      assign(paste0("hr","_",a),hr,envir = .GlobalEnv)
      assign(paste0("p","_",a),p,envir = .GlobalEnv)      
      }
	}       
      })
	  	  
    if (length(ls(pattern = "^fit1_",envir = .GlobalEnv))>0) {
      fit_list<-ls(pattern = "fit1_",envir = .GlobalEnv)
      
      modulename_list<-ls(pattern = "modulename_",envir = .GlobalEnv)
      p_list<-ls(pattern = "^p_",envir = .GlobalEnv)
      hr_list<-ls(pattern = "hr_",envir = .GlobalEnv)
      
      assign("fit_list",fit_list,envir = .GlobalEnv)
      assign("modulename_list",modulename_list,envir = .GlobalEnv)
      assign("hr_list",hr_list,envir = .GlobalEnv)
      assign("p_list",p_list,envir = .GlobalEnv)
    }	
	
    if(exists("final_discriminative_gene_set")){
      lapply(seq.int(length(fit_list)),function(a){
        png(filename=paste0(get(modulename_list[a]),".png"),width = 800,height = 600)
        plot(get(fit_list[a]),main=get(modulename_list[a]),col = c(2,4),frame.plot=0,ylab="Survival Probability",xlab="Time (day)",cex.axis=1.5,cex.lab=1.5,cex.main=2)
        legend("top",legend = c("High risk group", "Low risk group"),text.col = c(2,4),bty = "n",horiz = TRUE,cex = 1.5)
        mtext(text = paste0("p = ",get(p_list[a])),side=3,adj = 1,line = -6,cex=1.5)
        mtext(text = paste0("HR = ",get(hr_list[a])),side=3,adj = 1,line = -8,cex = 1.5)
        dev.off()})      
    }

	  
  eq_val<-1
  expect_equal(eq_val,1)

  
  })

test_that("Feature Selection and Classification processes are succesful", {
  
  test_spec<-NULL
  train_spec<-NULL
  test_pval<-NULL
  train_pval<-NULL
  test_Ac<-NULL
  train_Ac<-NULL
  test_kappa<-NULL
  train_kappa<-NULL
  elected_genes<-NULL
  elected_genes_before<-NULL
  skip_value<-NULL
  control_data<-NULL
  nameless_disease_filtered_gene_data<-NULL
  disease_filtered_gene_data_before<-NULL
  para_fixer<-NULL
  train_sample_normal<-NULL
  train_sample_cancer<-NULL
  final_elected_check<-NULL
  train_test_val_check<-NULL
  spec_list<-NULL
  sens_list<-NULL
  nor_val<-NULL
  tum_val<-NULL
  nor_val_list<-NULL
  tum_val_list<-NULL
  test_fin_col<-NULL
  
  specific_check_val<-0
  niv_value<-0.1
  set_val<-1
  control_val<-0
  abc<-0
  
  all_names<-new_tissue_type_list
  actual_disease_filtered_gene_data<-subset(disease_filtered_gene_data,select=-tissue_type)
   
  repeat{
    
    
    if (ncol(disease_filtered_gene_data)<=2) {
      elected_genes<-elected_genes_before
      disease_filtered_gene_data<-disease_filtered_gene_data_before
      specific_check_val<-1
    }
    
    if (ncol(disease_filtered_gene_data)>2 & specific_check_val==0) {
      elected_val<-NULL
      elected_genes<-greedy.wilks(tissue_type ~ ., data=disease_filtered_gene_data,niveau=niv_value)
      nameless_disease_filtered_gene_data<-disease_filtered_gene_data[,-1]
      elected_val<-elected_genes$results$vars
      elected_val<-as.vector(elected_val)
      
      
      if (length(elected_val)!=ncol(nameless_disease_filtered_gene_data)) {
        try(nameless_disease_filtered_gene_data<-nameless_disease_filtered_gene_data[,..elected_val],silent = TRUE)
        try(nameless_disease_filtered_gene_data<-nameless_disease_filtered_gene_data[,elected_val],silent = TRUE)
        
      }
      
    }
    
    disease_filtered_gene_data<-cbind(all_names,nameless_disease_filtered_gene_data)
    
    
    if (nrow(elected_genes$results)>2 ) {
      elected_genes_before<-elected_genes
      nameless_disease_filtered_gene_data_before<-nameless_disease_filtered_gene_data
      disease_filtered_gene_data_before<-disease_filtered_gene_data
    }
    
    skip_value<-1
    
    if (is.null(skip_value)==FALSE) {
      
      spl <- sample.split(disease_filtered_gene_data$tissue_type, SplitRatio = 0.80)
      training_set <- subset(disease_filtered_gene_data, spl == TRUE)
      test_set <- subset(disease_filtered_gene_data, spl == FALSE)
      row.names(training_set) <- NULL
      row.names(test_set) <- NULL
      
      if (is.null(train_test_val_check)==TRUE) {
        
        train_check<-training_set
        test_check<-test_set
        train_test_val_check<-1
      }
      
      if(is.null(para_fixer)==TRUE) {
        tuning_action<-tune.svm(as.factor(tissue_type)~., data=training_set,
                                cost=10^(seq(-5,5,1)),gamma=10^(seq(-6,6,1)),scale=FALSE,probability=TRUE)
        svm_data<-tuning_action$best.model
      }

      check_training_set<-subset(training_set,select=-tissue_type)
      check_testing_set<-subset(test_set,select=-tissue_type)
      
      
      t_pred<-predict(svm_data,type="prob",check_training_set,probability =TRUE )
      y_pred <- predict(svm_data,type="prob", check_testing_set,probability =TRUE)
      
      
      train_table<-confusionMatrix(t_pred, as.factor(training_set$tissue_type))
      test_table<-confusionMatrix(y_pred,as.factor(test_set$tissue_type))
      
      test_spec<-test_table$byClass[2]
      train_spec<-train_table$byClass[2]
      train_sens<-train_table$byClass[1]
      
      test_pval<-test_table$overall[6]
      train_pval<-train_table$overall[6]
      test_kappa<-test_table$overall[2]
      train_kappa<-train_table$overall[2]
      
      
      if (train_spec>0.8 & train_kappa>0.8 & train_pval<0.05 & test_pval<0.05 & test_kappa>0.8 & test_spec>0.8) {
        
        
        final_elected_check<-elected_genes
        final_gene_list<-colnames(disease_filtered_gene_data[,-1])
		
        set_val<-set_val+1
        disease_filtered_gene_data<-cbind(all_names,actual_disease_filtered_gene_data)
        specific_check_val<-0
        para_fixer<-NULL
        elected_genes_before<-NULL
        nameless_disease_filtered_gene_data_before<-NULL
        disease_filtered_gene_data_before<-NULL
        
        
        if (test_pval<0.05) {
          if (final_elected_check$results$p.value.diff[length(final_elected_check$results$p.value.diff)]>0.05 & final_elected_check$results$p.value.diff[length(final_elected_check$results$p.value.diff)-1]<0.05) {
            final_gene_list<-as.data.frame(final_gene_list)
            colnames(final_gene_list)<-"Names"
            assign("final_discriminative_gene_set",final_gene_list,envir =.GlobalEnv)
            eq_val<-1
            expect_equal(eq_val,1)
            break}
          
          if (final_elected_check$results$p.value.diff[length(final_elected_check$results$p.value.diff)]<0.05) {
            final_gene_list<-as.data.frame(final_gene_list)
            colnames(final_gene_list)<-"Names"
            assign("final_discriminative_gene_set",final_gene_list,envir =.GlobalEnv)
            eq_val<-1
            expect_equal(eq_val,1)
            break}
        }
        niv_value<-niv_value-0.01
      }                              
      
    }
    skip_value<-NULL
    gc()                   
  }

  
})

test_that("Disease Ontology-based Gene Selection is succesful", {
  
  globalVariables("new_tissue_type_list")

  normal_samples<-NULL
  tumour_samples<-NULL
  disease_filtered_gene_data<-NULL
  changed_name_plus_var_imp_genes_table<-NULL
  
  changed_whole_data<-cbind(tissue_type_list,top_genes)
  collect_gene_names<-NULL
  selected_data<-colnames(changed_whole_data[,-1])
  
  checking_data<-selected_data
  checking_data<-as.character(checking_data)
  checking_data<-gsub( "__", "-",checking_data)
  
  colnames(changed_whole_data[,seq.int(2,ncol(changed_whole_data))])<-checking_data
  database_selection<-select(org.Hs.eg.db, keys = checking_data,columns = c("ENTREZID", "SYMBOL"),keytype = "SYMBOL")
  
  pop_gene_id<-database_selection$ENTREZID
  pop_gene_symbol<-database_selection$SYMBOL
  count_gene_id<-length(database_selection$ENTREZID)
  
  dis_gene_extract<-lapply(seq_along(pop_gene_id),function(x){
    disease_enrichment<-enrichDO(pop_gene_id[x],ont = "HDO")
    if (!is.null(disease_enrichment)){
      dis_length<-length(disease_enrichment[1]$Description)
      p_check<-(disease_enrichment[1]$p.adjust[1])
      if (dis_length > 0){
        if (isTRUE(p_check < 0.05)==TRUE) {
          selected_gene_list<-c(collect_gene_names,pop_gene_symbol[x])
        }
      }
    }
  })
  
  collect_gene_names<-unlist(dis_gene_extract)
  collect_gene_names<-gsub( "-", "__",collect_gene_names)
  changed_whole_data<-changed_whole_data[,-1]
  changed_name_plus_var_imp_genes_table<-subset(changed_whole_data,select=(collect_gene_names))
  
  samp_select_norm<-lapply(seq.int(nrow(tissue_type_list)), function(x){
    if (str_contains(tissue_type_list$tissue_type[x],"Nor")) {
      normal_samples<-rbind("normal",normal_samples)
    }})
  samp_select_tum<-lapply(seq.int(nrow(tissue_type_list)), function(x){
    if (str_contains(tissue_type_list$tissue_type[x],"Tum")) {
      tumour_samples<-rbind("tumour",tumour_samples)
    }
  })
  
  normal_samples<-as.data.frame(unlist(samp_select_norm))
  tumour_samples<-as.data.frame(unlist(samp_select_tum))
  colnames(normal_samples)<-"tissue_type"
  colnames(tumour_samples)<-"tissue_type"
  assigning_new_tissue_type_list<-rbind(normal_samples,tumour_samples)
  rownames(assigning_new_tissue_type_list)<-NULL
  assign("new_tissue_type_list",assigning_new_tissue_type_list,envir = .GlobalEnv)
  
  if(exists("tcga_id_list")){
    tcga_id_list$id<-as.character(gsub("-", ".", tcga_id_list$id, fixed = TRUE))
    assigning_tcga_sample_comb<-cbind(tcga_id_list,new_tissue_type_list)
    assign("tcga_sample_comb",assigning_tcga_sample_comb,envir =.GlobalEnv)
  }
  
  assigning_disease_filtered_gene_data<-cbind(new_tissue_type_list,changed_name_plus_var_imp_genes_table)
  assigning_disease_filtered_gene_data<-as.data.frame(assigning_disease_filtered_gene_data)
  assign("disease_filtered_gene_data",assigning_disease_filtered_gene_data,envir = .GlobalEnv)
  eq_val<-1
  expect_equal(eq_val,1)
  
})

test_that("Differential Expression Analysis is succesful", {
  
  globalVariables("tissue_type_list")
  
  c_path<-system.file("extdata","coad_exp_sum.rds",package="SVMDO",mustWork = TRUE)
  c<-readRDS(c_path)
  c<-assay(c)  
  col_val_1<-NULL
  col_val_2<-NULL  
  type_num_data<-seq.int(ncol(c))
  type_data<-c[1,type_num_data]
  
  type_apply_1<-lapply(type_data,is.character)
  type_loc_1<-as.numeric(min((which(type_apply_1==TRUE))))
  

  
  if (!is.character(c[[type_loc_1+1]])) {
    
    type_loc_2<-type_loc_1+1
    col_val_1<-type_loc_1
    col_val_2<-type_loc_2
    
    assigning_tissue_type_list<-as.data.frame(c[[col_val_1]])
    colnames(assigning_tissue_type_list)<-c("tissue_type")
    assign("tissue_type_list",assigning_tissue_type_list,envir =.GlobalEnv)
    
    start_val<-type_loc_1
    num_data<-start_val+1
  }else{
    type_loc_2<-type_loc_1+2
    col_val_1<-type_loc_1
    col_val_2<-type_loc_2
    
    assigning_tcga_id_list<-as.data.frame(c[[col_val_1]])
    assigning_tissue_type_list<-as.data.frame(c[[col_val_1+1]])
    
    colnames(assigning_tcga_id_list)<-data.frame("id")
    colnames(assigning_tissue_type_list)<-c("tissue_type")
    
    assign("tissue_type_list",assigning_tissue_type_list,envir =.GlobalEnv)
    assign("tcga_id_list",assigning_tcga_id_list,envir =.GlobalEnv)
    
    start_val<-type_loc_1+1
    num_data<-start_val+2
    
  }  
  c<-c[,num_data:ncol(c)]
  c<-cbind(tissue_type_list,c)
  
  normal_data<-NULL
  tumour_data<-NULL
  p_val_total<-NULL
  normal_data_mean<-NULL
  tumour_data_mean<-NULL
  int_col<-NULL
  dist_normal_pval<-NULL
  dist_tumour_pval<-NULL
  
  
  i<-1:ncol(c)
  u<-duplicated(colnames(c))
  df<-which(u[i]==TRUE)
  d<-colnames(c)[df]
  duplicate_number<-as.data.frame(d)
  
  for(j in 1:nrow(duplicate_number)){
    colnames(c)[df[j]]<-paste0(colnames(c)[df[j]],"__",j)
  }
  
  
  #####Modifying illegal symbols
  colnames(c)<-gsub( "-", "__",  colnames(c))
  colnames(c)<-gsub( " ", "__",  colnames(c))
  colnames(c)<-gsub( ";. ", "__",colnames(c))
  colnames(c)<-gsub( ";__","__", colnames(c))
  #####
  
  
  ############ Normal and Tumour Data Extraction and Fold Change Calculation
  
    normal_data<-c[grep("Nor",c$tissue_type),]
    tumour_data<-c[grep("Tum",c$tissue_type),]
    
    num_data_norm<-(seq.int(start_val,ncol(normal_data)))
    num_data_tum<-(seq.int(start_val,ncol(tumour_data)))
    normal_data_mean<-colMeans(normal_data[,num_data_norm])
    tumour_data_mean<-colMeans(tumour_data[,num_data_tum])
    
    fold_change<-tumour_data_mean/normal_data_mean
    matr_fold<-as.matrix(fold_change)
    
    i<-start_val
    u<-start_val
    s<-start_val
      
    dist_normal_pval<-ad.test(normal_data[[i]][seq.int(ncol(normal_data))])$p.value
    dist_tumour_pval<-ad.test(tumour_data[[i]][seq.int(ncol(tumour_data))])$p.value
	
    repeat{
     if (!is.null(dist_normal_pval) & (dist_normal_pval>=0.05 | dist_tumour_pval>=0.05)) {
       dist_normal_pval<-ad.test(normal_data[[i]][seq.int(ncol(normal_data))])$p.value
       dist_tumour_pval<-ad.test(tumour_data[[i]][seq.int(ncol(tumour_data))])$p.value
       if (i==ncol(normal_data)) {
         p_val<-z.test(normal_data[[s]],tumour_data[[s]],sigma.x = sd(normal_data[[s]]),sigma.y = sd(tumour_data[[s]]))$p.value
         p_val_total<-c(p_val_total,p_val)
         s<-s+1
       }else{
         i<-i+1
       }
     }
     
     if (dist_normal_pval<0.05 | dist_tumour_pval<0.05) {
       p_val<-wilcox.test(as.numeric(unlist(normal_data[[u]])),as.numeric(unlist(tumour_data[[u]])))$p.value
       p_val_total<-c(p_val_total,p_val)
       u<-u+1
     }
     if (u>ncol(normal_data) | s>ncol(normal_data)) {
       break
     }
   }
  
  padjust<-p.adjust(p_val_total,method = "BH")
  p_val_total<-padjust                                        
  rownames(p_val_total)<-NULL
  filtered_p_val_total<-subset(p_val_total,p_val_total<0.05)
  bound_form<-cbind.data.frame(matr_fold,p_val_total)
  colnames(bound_form)<-c("Fold_Change","P_value(adjusted)")
  new_bound_form<-subset(bound_form,bound_form$Fold_Change!="Inf" & bound_form$Fold_Change!="-Inf"
                         &bound_form$Fold_Change!="NaN" &bound_form$`P_value(adjusted)`<0.05 &bound_form$`P_value(adjusted)`!="NaN")
  
  new_bound_form_A<-subset(new_bound_form,new_bound_form$Fold_Change<= 0.3535534)
  new_bound_form_B<-subset(new_bound_form,new_bound_form$Fold_Change>= 2.828427)
  
  new_bound_form_A<-cbind.data.frame(rownames(new_bound_form_A),new_bound_form_A)
  new_bound_form_B<-cbind.data.frame(rownames(new_bound_form_B),new_bound_form_B)
  colnames(new_bound_form_A)<-c("Genes","Fold_Change","P_value")
  colnames(new_bound_form_B)<-c("Genes","Fold_Change","P_value")
  complete_deg_gene_list<-rbind(new_bound_form_A,new_bound_form_B)
  
  
  sorted_new_bound_form_A<-new_bound_form_A[order(-new_bound_form_A$Fold_Change),]
  sorted_new_bound_form_B<-new_bound_form_B[order(new_bound_form_B$Fold_Change),]
  
  top_gene_number<-65
  
  if (nrow(sorted_new_bound_form_A) < top_gene_number | nrow(sorted_new_bound_form_B) < top_gene_number) {
    message_val_2<-1
    max_down_genes<-sorted_new_bound_form_A
    max_up_genes<-sorted_new_bound_form_B
    message("Insufficient gene number All up/downregulated genes were selected")
    message("Enter a lower value of input size")
  }else{
    max_down_genes<-sorted_new_bound_form_A[(nrow(sorted_new_bound_form_A)-(top_gene_number-1)):nrow(sorted_new_bound_form_A),]
    max_up_genes<-sorted_new_bound_form_B[(nrow(sorted_new_bound_form_B)-(top_gene_number-1)):nrow(sorted_new_bound_form_B),]
  }
  top_combined_genes<-rbind(max_down_genes,max_up_genes)
  rownames(top_combined_genes)<-top_combined_genes[,1]
  changed_whole_data<-subset(c,select=top_combined_genes$Genes)
  
  assign("top_genes",changed_whole_data,envir =.GlobalEnv)
  
  eq_val<-1
  expect_equal(eq_val,1)
  

})

---
title: "SVMDO-Tutorial"
author: "<h4>Author: <i>Mustafa Erhan Özer</i></h4>" 
date: "<h4>Most recent update: <i>`r format( Sys.Date(), '%b-%d-%Y')`</i></h4>"
output:
    BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{SVMDO-Tutorial}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  markdown: 
    wrap: 72
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  warning = FALSE,
  comment = "#>",
  cache = TRUE
)


is_windows <- identical(.Platform$OS.type, "windows")
```

# Installation and Package Loading

The day-to-day development version from the [Github
repository](https://github.com/robogeno/SVMDO) can be installed.

```{r install, eval=FALSE}
# From Github 
if (!requireNamespace("devtools", quietly=TRUE))
  install.packages("devtools")
devtools::install_github("robogeno/SVMDO")
```

```{r eval = FALSE}
# From Biocodunctor
if(!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("SVMDO")
```

```{r eval = FALSE}
#library(SVMDO)
#Main screen of GUI
#runGUI()
# OR
#SVMDO::runGUI()
```


# Introduction

Transcriptome-based supervised classification can be difficult to handle
due to including vast amount of junk features reducing the efficiency of
the process. To minimize the efficiency problem, feature selection
methods have been applied [1]. Ensemble methodology in constructing a
feature selection method has been mainly preferred for its better
accuracy in classification processes [2]. Cancer-based studies have been
reported to co-occur with several chronic diseases [3] and oncogenic
viral infections [4]. Disease Ontology (DO) enrichment analysis can
provide a filtration approach through reported diseases that interact
with the gene sets used [5]. Wilk's lambda criterion is one of the
moderate techniques for feature selection. The method combines different
features(genes) step by step based on their contributions to the
discriminating power of overall model [6]. Thus, disease related genes
with better discriminatory characteristics can be acquired. SVMDO is an
easy-to-use GUI using disease information for detecting tumor/normal
sample discriminating gene sets from differentially expressed genes. Our
approach is based on an iterative algorithm filtering genes with disease
ontology enrichment analysis and wilk's lambda criterion connected to
SVM classification model construction. Along with gene set extraction,
SVMDO also provides individual prognostic marker detection. The
algorithm is designed for FPKM and RPKM normalized RNA-Seq transcriptome
datasets. During the development our algorithm, Bioconductor provided a
robust approach for acquiring significant disease-gene interaction
information from disease ontology database.

# Implementation

SVMDO was developed by using Shiny package. It is available for Windows
and Linux from Bioconductor website. SVMDO requires the following R
packages: Shiny, ShinyFiles, golem, nortest, e1071, BSDA, data.table,
sjmisc, klaR, caTools, dplyr, caret, survival, DOSE, AnnotationDbi,
DOSE, org.Hs.eg.db

# Dataset Preparation

RNA-Seq cancer transcriptome and clinical datasets must be prepared
before applying them in SVMDO. The datasets must be used in **txt**
format. The expected designs of input datasets are indicated in Table-1
and Table-2 for transcriptome and clinical datasets respectively.

```{r echo=FALSE}
id<-c("TCGA-AA-3662","TCGA-AA-3514","TCGA-D5-6541","...")
tissue_type<-c("Normal","Normal","Tumour","...")
AB1G<-c("Exp_1","Exp_2","Exp_3","...")
A2M<-c("Exp_1","Exp_2","Exp_3","...")
table_prep_1<-data.frame(id,tissue_type,AB1G,A2M)
```

`r knitr::kable(table_prep_1,"pipe",col.name=c("id","tissue_type","AB1G","A2M"),align = "cccc",caption="Structure of RNA-Seq Transcriptome Dataset")`

```{r echo=FALSE}
id<-c("TCGA-AA-3662","TCGA-AA-3514","TCGA-D5-6541","...")
days_to_death<-c(49,1331,225,"...")
vital_status<-c("Alive","Dead","Dead","...")
table_prep_2<-data.frame(id,days_to_death,vital_status)
```

`r knitr::kable(table_prep_2,"pipe",col.name=c("id","days_to_death","vital_status"),align = "cccc",caption="Structure of Clinical Dataset")`

-   **tissue_type:** Normal/Tumour (or Tumor) Tissue Information
-   **A1BG, A2M:** Gene Symbol and Gene Expression
-   **id:** TCGA Sample Ids
-   **days_to_death:** Survival Time of Patients
-   **vital_status:** Vitality of Patients

Using **tissue_type** and **id** as column names for representing tissue
information and TCGA sample id is **mandatory**. If there is not any
requirement for **survival analysis**, preparation of **clinical
dataset** and involvement of **id** column in the transcriptome dataset
are optional.

# SVMDO GUI Description

The main dialog box is indicated in **Figure-1**. The GUI page consists
of two main sections which are "Analysis" and "Result". In the Analysis
section, steps of acquiring discriminative gene set and preparations of
individual survival plots are included. In the Result section,
visualization and download of discriminative gene set and survival plots
are included. At each step of the GUI sections, necessary variables are
saved as objects in the workspace environment to be used in the
following steps. To provide experience about the GUI usage, a test
section involving dummy example using SummarizedExperiment objects of
transcriptome (small form) and clinical datasets is also included.

```{r, ,echo=FALSE,  width = 200, height = 50,fig.align = "center",fig.show='hold'}
# two figs side by side
knitr::include_graphics("svmdo_fig_1.png")
```

<br><br><br>

```{r, ,echo=FALSE,  width = 200, height = 50,fig.align = "center",fig.show='hold',fig.cap='Figure-1 SVMDO GUI Sections'}
# two figs side by side
knitr::include_graphics("svmdo_fig_2.png")
```

# How to open SVMDO Main Screen

To open GUI screen, you can directly write **SVMDO::runGUI()** in R
console. If library is previously activated you can open GUI screen by
writing **runGUI()** in R console.

# How to use SVMDO Main Screen

(**Important:** Except file input processes, each step provides a
message box indicating process success/failure. It disappears after
clicking on any area in the GUI screen. This is necessary for continuing
the steps.)

## Steps of Analysis Screen

1.  To search your transcriptome dataset, use the file detection in
    **Choose Your Expression Dataset** section. The file will be
    automatically uploaded into the GUI.
2.  To prevent clashing with test datasets, select **"None"** option
    from the radio button section.
3.  By clicking on **DEG Analysis** button you further apply
    differential expression analysis. Labels of tissue_type column in
    dataset must contain "Nor" and "Tum" for determining normal/tumour
    (or tumor) samples.
4.  When the differential expression process is completed, a
    user-defined input size (n) is selected to filter the initial gene
    list (i.e., n number of upregulated and downregulated genes) by
    entering a number in **Input Size** section. It is predetermined as
    **50** in GUI which can be changed based on the user. A message
    window saying **process completed** will appear if there is not any
    problem. If there is problem with the value of input size, you will
    get a warning about inappropriate input size selection. If the input
    size remains, algorithm selects all of the differentiallly expressed
    genes to be used in the next process.
5.  To apply disease ontology-based gene filtration, click on **DO
    Analysis** button.
6.  To further apply the following feature selection and classification
    processes, click on the **Classification** button.
7.  Acquired discriminative gene set can be further used for survival
    analysis to detect individual prognostic genes. To apply this
    process, use the file detection in **Choose Clinical Data** section
    for searching clinical data about patient survival followed by
    clicking on **Survival Analysis** button.

## Steps of Result Screen

1.  To visualize discriminative gene sets inside GUI screen, click on
    **Show Gene Results** button. When you click this button, a table of
    gene set will appear.
2.  To visualize survival plots of individual genes, two steps have to
    be applied. First of all, click on **Prepare Plot Lists** button to
    feed plot information to the visualization system. After that, click
    on **Show Plots** button to visualize survival plots.
3.  Before downloading files, you can adjust the output directory with
    **Choose Directory** button. It can be used for separating files by
    selecting a destination before clicking download buttons. If it is
    desired, files can be downloaded to the same folder by selecting an
    output directory just one time before the download steps. If you do
    not select any output directory, files will be downloaded to your
    **working directory**.
4.  To download the resulting discriminative gene set, it is obligatory
    to define a filename in the **Enter Final Gene Set Filename**
    section. After that, you can click on **Download Gene List** button
    to complete the process.
5.  To download survival plots, you have to click on **Download Plot
    List** button. Names of plot files are automatically done by
    assigning gene names.

# Application of test datasets

SVMDO includes test datasets providing dummy examples for gaining experience on the GUI usage. Test datasets consists of summarized experiment objects including expression and clinical datasets. These objects are saved in RDA forms and called from **extdata** folder of the package. As expression datasets, test files includes simplified forms of TCGA-COAD (COAD) and TCGA-LUSC (LUSC) with 400 genes In test-based analysis, predetermined expression and clinical datasets are automatically uploaded into the GUI. Furthermore, predefined input size (n=50) is also automatically applied. Therefore, users have to continue with **DO Analysis** after **DEG Analysis** without adjusting input size.

# Workspace Clearance

When the user task is completed, click on the **Clear Environment**
button to remove the global variables created during the algorithm
sections. To prevent error in the next usages of GUI, it is a necessary
process. It can be applied at any moment without the necessity of
completing all of the steps of algorithm.

# Output Files of SVMDO

-   **Discriminative Gene Set:** Final form of gene set providing
    optimal classification performance
-   **Individiual Survival Plots:** Separate survival plots of
    individual genes with prognostic performance

# References

1.  Cai,J. et al. (2018) Feature selection in machine learning: A new
    perspective. Neurocomputing, 300, 70--79.
2.  Gallagher,E.J. and LeRoith,D. (2015) Obesity and diabetes: The
    increased risk of cancer and cancer-related mortality. Physiological
    Reviews, 95, 727--748.
3.  Kori,M. and Arga,K.Y. (2020) Pathways involved in viral oncogenesis:
    New perspectives from virus-host protein interactomics. Biochimica
    et Biophysica Acta (BBA) - Molecular Basis of Disease, 1866, 165885.
4.  LePendu,P. et al. (2011) Enabling enrichment analysis with the human
    disease ontology. Journal of Biomedical Informatics, 44, S31--S38.
5.  Liu,B. et al. (2004) BMC Bioinformatics, 5, 136.
6.  Ouardighi,A. el et al. (2007) Feature selection on supervised
    classification using wilks lambda statistic. In, 2007 international
    symposium on computational intelligence and intelligent informatics.
    IEEE.

# How to install R and RStudio GUI

RStudio requires R 3.3.0+. Choose a version of R that matches your
computer's operating system

## Windows Operating System

\*\*R-base Install:

1.  Copy/Paste the address <https://posit.co/download/rstudio-desktop/>
2.  Click on "Download and install R"
3.  In the new page, click on "Download R for Windows"
4.  Click on "install R for the first time"
5.  Click on "Download R-X.X.X-win.exe for Windows"to install R-base

\*\*RStudio Install:

1.  Copy/Paste the address <https://posit.co/download/rstudio-desktop/>
2.  Click on either download RStudio desktop for windows
3.  Alternatively, .exe /.zip versions can be downloaded from All
    Installers section

## Ubuntu Operating System

\*\*R-base Install:

1.  Copy/Paste the address <https://posit.co/download/rstudio-desktop/>
2.  Click on "Download and install R".
3.  Click on "Download R for Linux"
4.  In the parent directory, click on ubuntu/
5.  Run the following lines in terminal (as root or by prefixing sudo)
    to provide access to recent version of R:

-   sudo apt install --no-install-recommends software-properties-common
    dirmngr \# add the signing key (by Michael Rutter) for these repos
    \# To verify key, run gpg --show-keys
    /etc/apt/trusted.gpg.d/cran_ubuntu_key.asc \# Fingerprint:
    E298A3A825C0D65DFD57CBB651716619E084DAB9
-   wget -qO-
    <https://cloud.r-project.org/bin/linux/ubuntu/marutter_pubkey.asc>
    \| sudo tee -a /etc/apt/trusted.gpg.d/cran_ubuntu_key.asc \# add the
    R 4.0 repo from CRAN -- adjust 'focal' to 'groovy' or 'bionic' as
    needed
-   sudo add-apt-repository "deb
    <https://cloud.r-project.org/bin/linux/ubuntu> \$(lsb_release
    -cs)-cran40/"

5.  After the previous lines, run sudo apt install
    --no-install-recommends r-base

\*\*RStudio Install:

1.  Copy/Paste the address <https://posit.co/download/rstudio-desktop/>
2.  In All Installers section, select .deb or .debian.tar.gz version for
    Ubuntu
3.  Right click on the download and/or unzipped .deb file to install
    RStudio (Alternatively, .deb file can be installed from terminal by
    typing sudo dpkg -i installed_Rstudio_file.deb)

# Session Info

```{r SessionInfo, eval=TRUE, message=FALSE, echo=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_list_ui.R
\name{plot_list_ui}
\alias{plot_list_ui}
\alias{innerUI_collect_plot_data}
\title{SVMDO}
\usage{
innerUI_collect_plot_data(id)
}
\arguments{
\item{id}{connection output}
}
\value{
UI section of preparing plot list to be visualized in GUI page
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deg_server.R
\name{deg_server}
\alias{deg_server}
\alias{innerServer_3}
\title{SVMDO}
\usage{
innerServer_3(input, output, session, rawData, rval)
}
\arguments{
\item{input}{server input}

\item{output}{server output}

\item{session}{server session}

\item{rawData}{expression dataset provided from innerServer_exp_server}

\item{rval}{Selected radio button information provided from innerServer_rad_server}
}
\value{
Server section of differential gene expression analysis
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_show_server.R
\name{plot_show_server}
\alias{plot_show_server}
\title{SVMDO}
\usage{
plot_show_server(input, output, session, max_data)
}
\arguments{
\item{input}{server input}

\item{output}{server output}

\item{session}{server session}

\item{max_data}{Information of total number of survival plots prepared with discriminative gene set}
}
\value{
Server section of providing information about total number of survival plots for visualization
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/survival_analysis_server.R
\name{survival_analysis_server}
\alias{survival_analysis_server}
\alias{innerServer_8}
\title{SVMDO}
\usage{
innerServer_8(input, output, session, rawData_2, rval)
}
\arguments{
\item{input}{server input}

\item{output}{server output}

\item{session}{server session}

\item{rawData_2}{Clinical data provided from clinic_data_input_server}

\item{rval}{Selected radio button information provided from innerServer_rad_server}
}
\value{
Server section of survival analysis of final discriminative gene set
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/table_ui.R
\name{table_ui}
\alias{table_ui}
\alias{innerUI_table_show}
\title{SVMDO}
\usage{
innerUI_table_show(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of providing discriminative gene set for preparing table
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/test_data_selection_ui.R
\name{test_data_selection_ui}
\alias{test_data_selection_ui}
\alias{innerUI_test_data}
\title{SVMDO}
\usage{
innerUI_test_data(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of providing information about selected radio button
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_list_server.R
\name{plot_list_server}
\alias{plot_list_server}
\title{SVMDO}
\usage{
plot_list_server(input, output, session)
}
\arguments{
\item{input}{server input}

\item{output}{server output}

\item{session}{server session}
}
\value{
Server section of preparing plot list to be visualized in GUI page
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/top_val_server.R
\name{top_val_server}
\alias{top_val_server}
\alias{innerServer_4}
\title{SVMDO}
\usage{
innerServer_4(input, output, session)
}
\arguments{
\item{input}{server input}

\item{output}{server output}

\item{session}{server session}
}
\value{
Server section of entering top gene value
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/top_val_based_deg_filtration_server.R
\name{top_val_based_deg_filtration}
\alias{top_val_based_deg_filtration}
\alias{innerServer_5}
\title{SVMDO}
\usage{
innerServer_5(input, output, session, top_val)
}
\arguments{
\item{input}{server input}

\item{output}{server output}

\item{session}{server session}

\item{top_val}{top gene number value provided from top_val_server}
}
\value{
Server section of selecting differentially expressed genes based on top gene value
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runApp.R
\name{runGUI}
\alias{runGUI}
\alias{linebreaks}
\title{SVMDO}
\usage{
linebreaks(n)
}
\arguments{
\item{n}{linebreak function variable}
}
\value{
Returning GUI window screen
}
\description{
SVMDO
}
\examples{
#SVMDO::runGUI() Calling GUI without activating library
#runGUI() Calling GUI after activating library
# Disease Ontology Enrichment of a differentially expresed gene (entrez id):
a_1<-DOSE::enrichDO(2981,ont="HDO")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene_directory_selection_ui.R
\name{gene_directory_selection_ui}
\alias{gene_directory_selection_ui}
\alias{innerUI_path}
\title{SVMDO}
\usage{
innerUI_path(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of entering output/working for gene list directory
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene_list_name_server.R
\name{gene_list_name_server}
\alias{gene_list_name_server}
\alias{innerServer_10}
\title{SVMDO}
\usage{
innerServer_10(input, output, session)
}
\arguments{
\item{input}{server input}

\item{output}{server output}

\item{session}{server session}
}
\value{
Server section of entering final gene list name
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/globals.R
\name{globals}
\alias{globals}
\title{SVMDO}
\value{
Including script files and global variables of GUI required to be
initiated at the runApp file execution
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/surv_plot_dw_ui.R
\name{surv_plot_dw_ui}
\alias{surv_plot_dw_ui}
\alias{surv_plots_download_ui}
\title{SVMDO}
\usage{
surv_plots_download_ui(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of downloading survival plots of discriminative gene set
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene_list_table_visualization_ui.R
\name{gene_list_table_visualization_ui}
\alias{gene_list_table_visualization_ui}
\alias{deg_data_table_ui}
\title{SVMDO}
\usage{
deg_data_table_ui(id)
}
\arguments{
\item{id}{connection input}
}
\value{
Providing table form of discriminative gene sets in GUI
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package_req_list.R
\name{package_req_list}
\alias{package_req_list}
\title{SVMDO}
\value{
List of packages involved in SVMDO
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_show_ui.R
\name{plot_show_ui}
\alias{plot_show_ui}
\alias{innerUI_plot_show}
\title{SVMDO}
\usage{
innerUI_plot_show(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of providing information about total number of survival plots for visualization
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deg_ui.R
\name{deg_ui}
\alias{deg_ui}
\alias{innerUI_deg_analysis}
\title{SVMDO}
\usage{
innerUI_deg_analysis(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of differential gene expression analysis
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/top_val_ui.R
\name{top_val_ui}
\alias{top_val_ui}
\alias{innerUI_top_gene_val}
\title{SVMDO}
\usage{
innerUI_top_gene_val(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of entering top gene value
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/disc_gene_dw_server.R
\name{disc_gene_dw_server}
\alias{disc_gene_dw_server}
\title{SVMDO}
\usage{
disc_gene_dw_server(input, output, session, gene_list_val)
}
\arguments{
\item{input}{server input}

\item{output}{server output}

\item{session}{server session}

\item{gene_list_val}{discriminative gene set list variable}
}
\value{
Server section of discriminative gene set download button
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expression_dataset_input_ui.R
\name{innerServer_exp_ui}
\alias{innerServer_exp_ui}
\alias{innerUI_exp_data}
\title{SVMDO}
\usage{
innerUI_exp_data(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of providing expression dataset into GUI
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene_list_name_ui.R
\name{gene_list_name_ui}
\alias{gene_list_name_ui}
\alias{innerUI_gene_names}
\title{SVMDO}
\usage{
innerUI_gene_names(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of entering top gene value
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classification_ui.R
\name{classification_ui}
\alias{classification_ui}
\alias{innerUI_classification}
\title{SVMDO}
\usage{
innerUI_classification(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of wilks lambda filtration and SVM classification of disease filtered differentially expressed gene set
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/do_based_gene_filtration_ui.R
\name{do_based_gene_filtration_ui}
\alias{do_based_gene_filtration_ui}
\alias{innerUI_disease_ont_class}
\title{SVMDO}
\usage{
innerUI_disease_ont_class(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of disease ontology based filtration of differentially expressed genes
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/survival_analysis_ui.R
\name{survival_analysis_ui}
\alias{survival_analysis_ui}
\alias{innerUI_surv}
\title{SVMDO}
\usage{
innerUI_surv(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of survival analysis of final discriminative gene set
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinic_data_input_ui.R
\name{clinic_data_input_ui}
\alias{clinic_data_input_ui}
\alias{innerUI_clinic_data}
\title{SVMDO}
\usage{
innerUI_clinic_data(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of loading clinical data
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gui_obj_removal_ui.R
\name{gui_obj_removal_ui}
\alias{gui_obj_removal_ui}
\alias{innerUI_clear_env}
\title{SVMDO}
\usage{
innerUI_clear_env(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of workspace clearance
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/top_val_based_deg_filtration_ui.R
\name{top_val_based_deg_filtration_ui}
\alias{top_val_based_deg_filtration_ui}
\alias{innerUI_top_gene_selection}
\title{SVMDO}
\usage{
innerUI_top_gene_selection(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of selecting differentially expressed genes based on top gene value
}
\description{
SVMDO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/disc_gene_dw_ui.R
\name{disc_gene_download_ui}
\alias{disc_gene_download_ui}
\title{SVMDO}
\usage{
disc_gene_download_ui(id)
}
\arguments{
\item{id}{connection input}
}
\value{
UI section of discriminative gene set download button
}
\description{
SVMDO
}
